searchNodes=[{"ref":"Mix.html","title":"Mix","type":"module","doc":"Mix is a build tool that provides tasks for creating, compiling, and testing Elixir projects, managing its dependencies, and more. Mix.Project The foundation of Mix is a project. A project can be defined by using Mix.Project in a module, usually placed in a file named mix.exs: defmodule MyApp.MixProject do use Mix.Project def project do [ app: :my_app, version: &quot;1.0.0&quot; ] end end See the Mix.Project module for detailed documentation on Mix projects. Once the project is defined, a number of default Mix tasks can be run directly from the command line: mix compile - compiles the current project mix test - runs tests for the given project mix run - runs a particular command inside the project Each task has its own options and sometimes specific configuration to be defined in the project/0 function. You can use mix help to list all available tasks and mix help NAME to show help for a particular task. The best way to get started with your first project is by calling mix new my_project from the command line. Mix.Task Tasks are what make Mix extensible. Projects can extend Mix behaviour by adding their own tasks. For example, adding the task below inside your project will make it available to everyone that uses your project: defmodule Mix.Tasks.Hello do use Mix.Task def run(_) do Mix.shell().info(&quot;Hello world&quot;) end end The task can now be invoked with mix hello. See the Mix.Task behaviour for detailed documentation on Mix tasks. Dependencies Mix also manages your dependencies and integrates nicely with the Hex package manager. In order to use dependencies, you need to add a :deps key to your project configuration. We often extract the list of dependencies into its own function: defmodule MyApp.MixProject do use Mix.Project def project do [ app: :my_app, version: &quot;1.0.0&quot;, deps: deps() ] end defp deps do [ {:ecto, &quot;~&gt; 2.0&quot;}, {:plug, github: &quot;elixir-lang/plug&quot;} ] end end You can run mix help deps to learn more about dependencies in Mix. Environments Mix supports different environments. Environments allow developers to prepare and organize their project specifically for different scenarios. By default, Mix provides three environments: :dev - the default environment :test - the environment mix test runs on :prod - the environment your dependencies run on The environment can be changed via the command line by setting the MIX_ENV environment variable, for example: $ MIX_ENV=prod mix run server.exs You can also specify that certain dependencies are available only for certain environments: {:some_test_dependency, &quot;~&gt; 1.0&quot;, only: :test} The environment can be read via Mix.env/0. Targets Besides environments, Mix supports targets. Targets are useful when a project needs to compile to different architectures and some of the dependencies are only available to some of them. By default, the target is :host but it can be set via the MIX_TARGET environment variable. The target can be read via Mix.target/0. Aliases Aliases are shortcuts or tasks specific to the current project. In the &quot;Mix.Task&quot; section, we have defined a task that would be available to everyone using our project as a dependency. What if we wanted the task to only be available for our project? Just define an alias: defmodule MyApp.MixProject do use Mix.Project def project do [ app: :my_app, version: &quot;1.0.0&quot;, aliases: aliases() ] end defp aliases do [ c: &quot;compile&quot;, hello: &amp;hello/1 ] end defp hello(_) do Mix.shell().info(&quot;Hello world&quot;) end end In the example above, we have defined two aliases. One is mix c which is a shortcut for mix compile. The other is named mix hello, which is the equivalent to the Mix.Tasks.Hello we have defined in the &quot;Mix.Task&quot; section. Aliases may also be lists, specifying multiple tasks to be run consecutively: [all: [&amp;hello/1, &quot;deps.get --only \#{Mix.env()}&quot;, &quot;compile&quot;]] In the example above, we have defined an alias named mix all, that prints &quot;Hello world&quot;, then fetches dependencies specific to the current environment, and compiles the project. Arguments given to the alias will be appended to the arguments of the last task in the list, if the last task is a function they will be given as a list of strings to the function. Finally, aliases can also be used to augment existing tasks. Let&#39;s suppose you want to augment mix clean to clean another directory Mix does not know about: [clean: [&quot;clean&quot;, &amp;clean_extra/1]] Where &amp;clean_extra/1 would be a function in your mix.exs with extra cleanup logic. Aliases defined in the current project do not affect its dependencies and aliases defined in dependencies are not accessible from the current project. Aliases can be used very powerfully to also run Elixir scripts and shell commands, for example: # priv/hello1.exs IO.puts(&quot;Hello One&quot;) # priv/hello2.exs IO.puts(&quot;Hello Two&quot;) # priv/world.sh #!/bin/sh echo &quot;world!&quot; # mix.exs defp aliases do [ some_alias: [&quot;hex.info&quot;, &quot;run priv/hello1.exs&quot;, &quot;cmd priv/world.sh&quot;] ] end In the example above we have created the alias some_alias that will run the task mix hex.info, then mix run to run an Elixir script, then mix cmd to execute a command line shell script. This shows how powerful aliases mixed with Mix tasks can be. Mix tasks are designed to run only once. This prevents the same task to be executed multiple times. For example, if there are several tasks depending on mix compile, the code will be compiled once. Tasks can be executed again if they are explicitly reenabled using Mix.Task.reenable/1: another_alias: [ &quot;format --check-formatted priv/hello1.exs&quot;, &quot;cmd priv/world.sh&quot;, fn _ -&gt; Mix.Task.reenable(&quot;format&quot;) end, &quot;format --check-formatted priv/hello2.exs&quot; ] The following tasks are automatically reenabled: mix cmd, mix do, mix loadconfig, mix profile.cprof, mix profile.eprof, mix profile.fprof, mix run, and mix xref. It is worth mentioning that some tasks, such as in the case of the format command in the example above, can accept multiple files so it could be rewritten as: another_alias: [&quot;format --check-formatted priv/hello1.exs priv/hello2.exs&quot;] Environment variables Several environment variables can be used to modify Mix&#39;s behaviour. Mix responds to the following variables: MIX_ARCHIVES - specifies the directory into which the archives should be installed MIX_BUILD_PATH - sets the project build_path config MIX_DEBUG - outputs debug information about each task before running it MIX_ENV - specifies which environment should be used. See Environments MIX_TARGET - specifies which target should be used. See Targets MIX_EXS - changes the full path to the mix.exs file MIX_HOME - path to Mix&#39;s home directory, stores configuration files and scripts used by Mix MIX_PATH - appends extra code paths MIX_QUIET - does not print information messages to the terminal MIX_REBAR - path to rebar command that overrides the one Mix installs MIX_REBAR3 - path to rebar3 command that overrides the one Mix installs Environment variables that are not meant to hold a value (and act basically as flags) should be set to either 1 or true, for example: $ MIX_DEBUG=1 mix compile"},{"ref":"Mix.html#compilers/0","title":"Mix.compilers/0","type":"function","doc":"Returns the default compilers used by Mix. It can be used in your mix.exs to prepend or append new compilers to Mix: def project do [compilers: Mix.compilers() ++ [:foo, :bar]] end"},{"ref":"Mix.html#debug/1","title":"Mix.debug/1","type":"function","doc":"Sets Mix debug mode."},{"ref":"Mix.html#debug?/0","title":"Mix.debug?/0","type":"function","doc":"Returns true if Mix is in debug mode."},{"ref":"Mix.html#env/0","title":"Mix.env/0","type":"function","doc":"Returns the Mix environment. This function should not be used at runtime in application code (as opposed to infrastructure and build code like Mix tasks). Mix is a build tool and may not be available after the code is compiled (for example in a release). To differentiate the program behavior depending on the environment, it is recommended to use application environment through Application.get_env/3. Proper configuration can be set in Mix.Config files, often per-environment (see Mix.Config.import_config/1 for more information)."},{"ref":"Mix.html#env/1","title":"Mix.env/1","type":"function","doc":"Changes the current Mix environment to env. Be careful when invoking this function as any project configuration won&#39;t be reloaded. This function should not be used at runtime in application code (see env/0 for more information)."},{"ref":"Mix.html#raise/1","title":"Mix.raise/1","type":"function","doc":"Raises a Mix error that is nicely formatted."},{"ref":"Mix.html#shell/0","title":"Mix.shell/0","type":"function","doc":"Returns the current shell. shell/0 can be used as a wrapper for the current shell. It contains conveniences for requesting information from the user, printing to the shell and so forth. The Mix shell is swappable (see shell/1), allowing developers to use a test shell that simply sends messages to the current process instead of performing IO (see Mix.Shell.Process). By default, this returns Mix.Shell.IO."},{"ref":"Mix.html#shell/1","title":"Mix.shell/1","type":"function","doc":"Sets the current shell. After calling this function, shell becomes the shell that is returned by shell/0."},{"ref":"Mix.html#target/0","title":"Mix.target/0","type":"function","doc":"Returns the Mix target."},{"ref":"Mix.html#target/1","title":"Mix.target/1","type":"function","doc":"Changes the current Mix target to target. Be careful when invoking this function as any project configuration won&#39;t be reloaded."},{"ref":"Mix.Config.html","title":"Mix.Config","type":"module","doc":"Module for defining, reading and merging app configurations. Most commonly, this module is used to define your own configuration: use Mix.Config config :plug, key1: &quot;value1&quot;, key2: &quot;value2&quot; import_config &quot;\#{Mix.env}.exs&quot; All config/* macros, including import_config/1, are used to help define such configuration files. Furthermore, this module provides functions like read!/1, merge/2 and friends which help manipulate configurations in general. Configuration set using Mix.Config will set the application environment, so that Application.get_env/3 and other Application functions can be used at run or compile time to retrieve or change the configuration. For example, the :key1 value from the application :plug (see example above) can be retrieved with: &quot;value1&quot; = Application.fetch_env!(:plug, :key1)"},{"ref":"Mix.Config.html#config/2","title":"Mix.Config.config/2","type":"function","doc":"Configures the given application. Keyword lists are always deep merged. Examples The given opts are merged into the existing configuration for the given app. Conflicting keys are overridden by the ones specified in opts. For example, the declaration below: config :lager, log_level: :warn, mode: :truncate config :lager, log_level: :info, threshold: 1024 Will have a final configuration of: [log_level: :info, mode: :truncate, threshold: 1024] This final configuration can be retrieved at run or compile time: Application.get_all_env(:lager)"},{"ref":"Mix.Config.html#config/3","title":"Mix.Config.config/3","type":"function","doc":"Configures the given key for the given application. Keyword lists are always deep merged. Examples The given opts are merged into the existing values for key in the given app. Conflicting keys are overridden by the ones specified in opts. For example, given the two configurations below: config :ecto, Repo, log_level: :warn, adapter: Ecto.Adapters.Postgres config :ecto, Repo, log_level: :info, pool_size: 10 the final value of the configuration for the Repo key in the :ecto application will be: [log_level: :info, pool_size: 10, adapter: Ecto.Adapters.Postgres] This final value can be retrieved at runtime or compile time with: Application.get_env(:ecto, Repo)"},{"ref":"Mix.Config.html#eval!/2","title":"Mix.Config.eval!/2","type":"function","doc":"Evaluates the given configuration file. It accepts a list of imported_paths that should raise if attempted to be imported again (to avoid recursive imports). It returns a tuple with the configuration and the imported paths."},{"ref":"Mix.Config.html#import_config/1","title":"Mix.Config.import_config/1","type":"macro","doc":"Imports configuration from the given file or files. If path_or_wildcard is a wildcard, then all the files matching that wildcard will be imported; if no file matches the wildcard, no errors are raised. If path_or_wildcard is not a wildcard but a path to a single file, then that file is imported; in case the file doesn&#39;t exist, an error is raised. If path/wildcard is a relative path/wildcard, it will be expanded relatively to the directory the current configuration file is in. Examples This is often used to emulate configuration across environments: import_config &quot;\#{Mix.env}.exs&quot; Or to import files from children in umbrella projects: import_config &quot;../apps/*/config/config.exs&quot;"},{"ref":"Mix.Config.html#merge/2","title":"Mix.Config.merge/2","type":"function","doc":"Merges two configurations. The configuration of each application is merged together with the values in the second one having higher preference than the first in case of conflicts. Examples iex&gt; Mix.Config.merge([app: [k: :v1]], [app: [k: :v2]]) [app: [k: :v2]] iex&gt; Mix.Config.merge([app1: []], [app2: []]) [app1: [], app2: []]"},{"ref":"Mix.Config.html#persist/1","title":"Mix.Config.persist/1","type":"function","doc":"Persists the given configuration by modifying the configured applications environment. config should be a list of {app, app_config} tuples or a %{app =&gt; app_config} map where app are the applications to be configured and app_config are the configuration (as key-value pairs) for each of those applications. Returns the configured applications. Examples Mix.Config.persist(logger: [level: :error], my_app: [my_config: 1]) #=&gt; [:logger, :my_app]"},{"ref":"Mix.ElixirVersionError.html","title":"Mix.ElixirVersionError","type":"exception","doc":""},{"ref":"Mix.Error.html","title":"Mix.Error","type":"exception","doc":""},{"ref":"Mix.Generator.html","title":"Mix.Generator","type":"module","doc":"Conveniences for working with paths and generating content. All of these functions are verbose, in the sense they log the action to be performed via Mix.shell/0."},{"ref":"Mix.Generator.html#create_directory/1","title":"Mix.Generator.create_directory/1","type":"function","doc":"Creates a directory if one does not exist yet. This function does nothing if the given directory already exists; in this case, it still logs the directory creation. Examples iex&gt; Mix.Generator.create_directory(&quot;path/to/dir&quot;) * creating path/to/dir :ok"},{"ref":"Mix.Generator.html#create_file/3","title":"Mix.Generator.create_file/3","type":"function","doc":"Creates a file with the given contents. If the file already exists, asks for user confirmation. Options :force - forces installation without a shell prompt. Examples iex&gt; Mix.Generator.create_file(&quot;.gitignore&quot;, &quot;_build\\ndeps\\n&quot;) * creating .gitignore :ok"},{"ref":"Mix.Generator.html#embed_template/2","title":"Mix.Generator.embed_template/2","type":"macro","doc":"Embeds a template given by contents into the current module. It will define a private function with the name followed by _template that expects assigns as arguments. This function must be invoked passing a keyword list. Each key in the keyword list can be accessed in the template using the @ macro. For more information, check EEx.SmartEngine. Examples defmodule Mix.Tasks.MyTask do require Mix.Generator Mix.Generator.embed_template(:log, &quot;Log: &lt;%= @log %&gt;&quot;) end"},{"ref":"Mix.Generator.html#embed_text/2","title":"Mix.Generator.embed_text/2","type":"macro","doc":"Embeds a text given by contents into the current module. It will define a private function with the name followed by _text that expects no arguments. Examples defmodule Mix.Tasks.MyTask do require Mix.Generator Mix.Generator.embed_text(:error, &quot;There was an error!&quot;) end"},{"ref":"Mix.InvalidTaskError.html","title":"Mix.InvalidTaskError","type":"exception","doc":""},{"ref":"Mix.NoProjectError.html","title":"Mix.NoProjectError","type":"exception","doc":""},{"ref":"Mix.NoTaskError.html","title":"Mix.NoTaskError","type":"exception","doc":""},{"ref":"Mix.Project.html","title":"Mix.Project","type":"module","doc":"Defines and manipulates Mix projects. A Mix project is defined by calling use Mix.Project in a module, usually placed in mix.exs: defmodule MyApp.MixProject do use Mix.Project def project do [ app: :my_app, version: &quot;1.0.0&quot; ] end end Configuration In order to configure Mix, the module that uses Mix.Project should export a project/0 function that returns a keyword list representing configuration for the project. This configuration can be read using Mix.Project.config/0. Note that config/0 won&#39;t fail if a project is not defined; this allows many Mix tasks to work without a project. If a task requires a project to be defined or needs to access a special function within the project, the task can call Mix.Project.get!/0 which fails with Mix.NoProjectError in the case a project is not defined. There isn&#39;t a comprehensive list of all the options that can be returned by project/0 since many Mix tasks define their own options that they read from this configuration. For example, look at the &quot;Configuration&quot; section in the documentation for the Mix.Tasks.Compile task. These are a few options that are not used by just one Mix task (and will thus be documented here): :build_per_environment - if true, builds will be per-environment. If false, builds will go in _build/shared regardless of the Mix environment. Defaults to true. :aliases - a list of task aliases. For more information, check out the &quot;Aliases&quot; section in the documentation for the Mix module. Defaults to []. :config_path - a string representing the path of the main config file. See config_files/0 for more information. Defaults to &quot;config/config.exs&quot;. :default_task - a string representing the default task to be run by mix when no task is specified. Defaults to &quot;run&quot;. :deps - a list of dependencies of this project. Refer to the documentation for the Mix.Tasks.Deps task for more information. Defaults to []. :deps_path - directory where dependencies are stored. Also see deps_path/1. Defaults to &quot;deps&quot;. :lockfile - the name of the lockfile used by the mix deps.* family of tasks. Defaults to &quot;mix.lock&quot;. :preferred_cli_env - a keyword list of {task, env} tuples where task is the task name as an atom (for example, :&quot;deps.get&quot;) and env is the preferred environment (for example, :test). This option overrides what specified by the tasks with the @preferred_cli_env attribute (see the docs for Mix.Task). Defaults to []. For more options, keep an eye on the documentation for single Mix tasks; good examples are the Mix.Tasks.Compile task and all the specific compiler tasks (such as Mix.Tasks.Compile.Elixir or Mix.Tasks.Compile.Erlang). Note that sometimes the same configuration option is mentioned in the documentation for different tasks; this is just because it&#39;s common for many tasks to read and use the same configuration option (for example, :erlc_paths is used by mix compile.erlang, mix compile.yecc, and other tasks). Erlang projects Mix can be used to manage Erlang projects that don&#39;t have any Elixir code. To ensure Mix tasks work correctly for an Erlang project, language: :erlang has to be part of the configuration returned by project/0. This setting also makes sure Elixir is not added as a dependency to the generated .app file or to the escript generated with mix escript.build, and so on."},{"ref":"Mix.Project.html#app_path/1","title":"Mix.Project.app_path/1","type":"function","doc":"Returns the application path inside the build. The returned path will be expanded. Examples Mix.Project.app_path() #=&gt; &quot;/path/to/project/_build/shared/lib/app&quot;"},{"ref":"Mix.Project.html#apps_paths/1","title":"Mix.Project.apps_paths/1","type":"function","doc":"Returns a map with the umbrella child applications paths. These paths are based on the :apps_path and :apps configurations. If the given project configuration identifies an umbrella project, the return value is a map of app =&gt; path where app is a child app of the umbrella and path is its path relative to the root of the umbrella project. If the given project configuration does not identify an umbrella project, nil is returned. Examples Mix.Project.apps_paths() #=&gt; %{my_app1: &quot;apps/my_app1&quot;, my_app2: &quot;apps/my_app2&quot;}"},{"ref":"Mix.Project.html#build_path/1","title":"Mix.Project.build_path/1","type":"function","doc":"Returns the build path for the given project. If no configuration is given, the one for the current project is used. The returned path will be expanded. Examples Mix.Project.build_path() #=&gt; &quot;/path/to/project/_build/shared&quot; If :build_per_environment is set to true, it will create a new build per environment: Mix.env() #=&gt; :dev Mix.Project.build_path() #=&gt; &quot;/path/to/project/_build/dev&quot;"},{"ref":"Mix.Project.html#build_structure/2","title":"Mix.Project.build_structure/2","type":"function","doc":"Builds the project structure for the given application. Options :symlink_ebin - symlink ebin instead of copying it"},{"ref":"Mix.Project.html#clear_deps_cache/0","title":"Mix.Project.clear_deps_cache/0","type":"function","doc":"Clears the dependency for the current environment. Useful when dependencies need to be reloaded due to change of global state."},{"ref":"Mix.Project.html#compile/2","title":"Mix.Project.compile/2","type":"function","doc":"Compiles the given project."},{"ref":"Mix.Project.html#compile_path/1","title":"Mix.Project.compile_path/1","type":"function","doc":"Returns the paths the given project compiles to. If no configuration is given, the one for the current project will be used. The returned path will be expanded. Examples Mix.Project.compile_path() #=&gt; &quot;/path/to/project/_build/dev/lib/app/ebin&quot;"},{"ref":"Mix.Project.html#config/0","title":"Mix.Project.config/0","type":"function","doc":"Returns the project configuration. If there is no project defined, it still returns a keyword list with default values. This allows many Mix tasks to work without the need for an underlying project. Note this configuration is cached once the project is pushed onto the stack. Calling it multiple times won&#39;t cause it to be recomputed. Do not use Mix.Project.config/0 to find the runtime configuration. Use it only to configure aspects of your project (like compilation directories) and not your application runtime."},{"ref":"Mix.Project.html#config_files/0","title":"Mix.Project.config_files/0","type":"function","doc":"Returns a list of project configuration files for this project. This function is usually used in compilation tasks to trigger a full recompilation whenever such configuration files change. It returns the mix.exs file, the lock manifest, and all config files in the config directory that do not start with a trailing period (for example, .my_config.exs)."},{"ref":"Mix.Project.html#config_mtime/0","title":"Mix.Project.config_mtime/0","type":"function","doc":"Returns the latest modification time from config files. This function is usually used in compilation tasks to trigger a full recompilation whenever such configuration files change. For this reason, the mtime is cached to avoid file system lookups."},{"ref":"Mix.Project.html#consolidation_path/1","title":"Mix.Project.consolidation_path/1","type":"function","doc":"Returns the path where protocol consolidations are stored. The returned path will be expanded. Examples Mix.Project.consolidation_path() #=&gt; &quot;/path/to/project/_build/dev/lib/my_app/consolidated&quot; Inside umbrellas: Mix.Project.consolidation_path() #=&gt; &quot;/path/to/project/_build/dev/consolidated&quot;"},{"ref":"Mix.Project.html#deps_path/1","title":"Mix.Project.deps_path/1","type":"function","doc":"Returns the path where dependencies are stored for the given project. If no configuration is given, the one for the current project is used. The returned path will be expanded. Examples Mix.Project.deps_path() #=&gt; &quot;/path/to/project/deps&quot;"},{"ref":"Mix.Project.html#deps_paths/1","title":"Mix.Project.deps_paths/1","type":"function","doc":"Returns the full path of all dependencies as a map. Options :depth - only return dependencies to the depth level, a depth of 1 will only return top-level dependencies :parents - starts the dependency traversal from the given parents instead of the application root Examples Mix.Project.deps_paths() #=&gt; %{foo: &quot;deps/foo&quot;, bar: &quot;custom/path/dep&quot;}"},{"ref":"Mix.Project.html#ensure_structure/2","title":"Mix.Project.ensure_structure/2","type":"function","doc":"Ensures the project structure for the given project exists. In case it does exist, it is a no-op. Otherwise, it is built."},{"ref":"Mix.Project.html#get/0","title":"Mix.Project.get/0","type":"function","doc":"Retrieves the current project if there is one. If there is no current project, nil is returned. This may happen in cases there is no mix.exs in the current directory. If you expect a project to be defined, i.e., it is a requirement of the current task, you should call get!/0 instead."},{"ref":"Mix.Project.html#get!/0","title":"Mix.Project.get!/0","type":"function","doc":"Same as get/0, but raises an exception if there is no current project. This is usually called by tasks that need additional functions on the project to be defined. Since such tasks usually depend on a project being defined, this function raises a Mix.NoProjectError exception in case no project is available."},{"ref":"Mix.Project.html#in_project/4","title":"Mix.Project.in_project/4","type":"function","doc":"Runs the given fun inside the given project. This function changes the current working directory and loads the project at the given directory onto the project stack. A post_config can be passed that will be merged into the project configuration. fun is called with the module name of the given Mix.Project. The return value of this function is the return value of fun. Examples Mix.Project.in_project(:my_app, &quot;/path/to/my_app&quot;, fn module -&gt; &quot;Mix project is: \#{inspect module}&quot; end) #=&gt; &quot;Mix project is: MyApp.MixProject&quot;"},{"ref":"Mix.Project.html#load_paths/1","title":"Mix.Project.load_paths/1","type":"function","doc":"Returns all load paths for the given project."},{"ref":"Mix.Project.html#manifest_path/1","title":"Mix.Project.manifest_path/1","type":"function","doc":"Returns the path where manifests are stored. By default they are stored in the app path inside the build directory. Umbrella applications have the manifest path set to the root of the build directory. Directories may be changed in future releases. The returned path will be expanded. Examples Mix.Project.manifest_path() #=&gt; &quot;/path/to/project/_build/shared/lib/app/.mix&quot;"},{"ref":"Mix.Project.html#umbrella?/1","title":"Mix.Project.umbrella?/1","type":"function","doc":"Returns true if config is the configuration for an umbrella project. When called with no arguments, tells whether the current project is an umbrella project."},{"ref":"Mix.SCM.html","title":"Mix.SCM","type":"behaviour","doc":"This module provides helper functions and defines the behaviour required by any source code manager (SCM) used by Mix."},{"ref":"Mix.SCM.html#c:accepts_options/2","title":"Mix.SCM.accepts_options/2","type":"callback","doc":"This behaviour function receives a keyword list of opts and should return an updated list in case the SCM consumes the available options. For example, when a developer specifies a dependency: {:foo, &quot;0.1.0&quot;, github: &quot;foo/bar&quot;} Each registered SCM will be asked if they consume this dependency, receiving [github: &quot;foo/bar&quot;] as argument. Since this option makes sense for the Git SCM, it will return an update list of options while other SCMs would simply return nil."},{"ref":"Mix.SCM.html#append/1","title":"Mix.SCM.append/1","type":"function","doc":"Appends the given SCM module to the list of available SCMs."},{"ref":"Mix.SCM.html#available/0","title":"Mix.SCM.available/0","type":"function","doc":"Returns all available SCMs. Each SCM is tried in order until a matching one is found."},{"ref":"Mix.SCM.html#c:checked_out?/1","title":"Mix.SCM.checked_out?/1","type":"callback","doc":"This behaviour function returns a boolean if the dependency is available."},{"ref":"Mix.SCM.html#c:checkout/1","title":"Mix.SCM.checkout/1","type":"callback","doc":"This behaviour function checks out dependencies. If the dependency is locked, a lock is received in opts and the repository must be check out at the lock. Otherwise, no lock is given and the repository can be checked out to the latest version. It must return the current lock."},{"ref":"Mix.SCM.html#c:equal?/2","title":"Mix.SCM.equal?/2","type":"callback","doc":"Receives two options and must return true if they refer to the same repository. The options are guaranteed to belong to the same SCM."},{"ref":"Mix.SCM.html#c:fetchable?/0","title":"Mix.SCM.fetchable?/0","type":"callback","doc":"Returns a boolean if the dependency can be fetched or it is meant to be previously available in the file system. Local dependencies (i.e. non-fetchable ones) are automatically recompiled every time the parent project is compiled."},{"ref":"Mix.SCM.html#c:format/1","title":"Mix.SCM.format/1","type":"callback","doc":"Returns a string representing the SCM. This is used when printing the dependency and not for inspection, so the amount of information should be concise and easy to spot."},{"ref":"Mix.SCM.html#c:format_lock/1","title":"Mix.SCM.format_lock/1","type":"callback","doc":"Returns a string representing the SCM. This is used when printing the dependency and not for inspection, so the amount of information should be concise and easy to spot. If nil is returned, it means no lock information is available."},{"ref":"Mix.SCM.html#c:lock_status/1","title":"Mix.SCM.lock_status/1","type":"callback","doc":"This behaviour function checks the status of the lock. In particular, it checks if the revision stored in the lock is the same as the repository it is currently in. It may return: :mismatch - if the lock doesn&#39;t match and we need to simply move to the latest lock :outdated - the repository options are outdated in the lock and we need to trigger a full update :ok - everything is fine The lock is sent via opts[:lock] but it may not always be available. In such cases, if the SCM requires a lock, it must return :mismatch, otherwise simply :ok. Note the lock may also belong to another SCM and as such, an structural check is required. A structural mismatch should always return :outdated."},{"ref":"Mix.SCM.html#c:managers/1","title":"Mix.SCM.managers/1","type":"callback","doc":"Returns the usable managers for the dependency. This can be used if the SCM has extra knowledge of the dependency, otherwise it should return an empty list."},{"ref":"Mix.SCM.html#prepend/1","title":"Mix.SCM.prepend/1","type":"function","doc":"Prepends the given SCM module to the list of available SCMs."},{"ref":"Mix.SCM.html#c:update/1","title":"Mix.SCM.update/1","type":"callback","doc":"This behaviour function updates dependencies. It may be called by deps.get or deps.update. In the first scenario, a lock is received in opts and the repository must be updated to the lock. In the second, no lock is given and the repository can be updated freely. It must return the current lock."},{"ref":"Mix.SCM.html#t:opts/0","title":"Mix.SCM.opts/0","type":"type","doc":""},{"ref":"Mix.Shell.html","title":"Mix.Shell","type":"behaviour","doc":"Defines Mix.Shell contract."},{"ref":"Mix.Shell.html#c:cmd/1","title":"Mix.Shell.cmd/1","type":"callback","doc":"Executes the given command and returns its exit status."},{"ref":"Mix.Shell.html#c:cmd/2","title":"Mix.Shell.cmd/2","type":"callback","doc":"Executes the given command and returns its exit status. Options :print_app - when false, does not print the app name when the command outputs something :stderr_to_stdout - when false, does not redirect stderr to stdout :quiet - when true, do not print the command output :env - environment options to the executed command"},{"ref":"Mix.Shell.html#cmd/3","title":"Mix.Shell.cmd/3","type":"function","doc":"Executes the given command as a shell command and invokes the callback for the streamed response. This is most commonly used by shell implementations but can also be invoked directly. Options :stderr_to_stdout - redirects stderr to stdout, defaults to true :env - a list of environment variables, defaults to [] :quiet - overrides the callback to no-op"},{"ref":"Mix.Shell.html#c:error/1","title":"Mix.Shell.error/1","type":"callback","doc":"Prints the given ANSI error to the shell."},{"ref":"Mix.Shell.html#c:info/1","title":"Mix.Shell.info/1","type":"callback","doc":"Prints the given ANSI message to the shell."},{"ref":"Mix.Shell.html#c:print_app/0","title":"Mix.Shell.print_app/0","type":"callback","doc":"Prints the current application to the shell if it was not printed yet."},{"ref":"Mix.Shell.html#printable_app_name/0","title":"Mix.Shell.printable_app_name/0","type":"function","doc":"Returns the printable app name. This function returns the current application name, but only if the application name should be printed. Calling this function automatically toggles its value to false until the current project is re-entered. The goal is to avoid printing the application name multiple times."},{"ref":"Mix.Shell.html#c:prompt/1","title":"Mix.Shell.prompt/1","type":"callback","doc":"Prompts the user for input."},{"ref":"Mix.Shell.html#c:yes?/1","title":"Mix.Shell.yes?/1","type":"callback","doc":"Prompts the user for confirmation."},{"ref":"Mix.Shell.IO.html","title":"Mix.Shell.IO","type":"module","doc":"This is Mix&#39;s default shell. It simply prints messages to stdio and stderr."},{"ref":"Mix.Shell.IO.html#cmd/2","title":"Mix.Shell.IO.cmd/2","type":"function","doc":"Executes the given command and prints its output to stdout as it comes."},{"ref":"Mix.Shell.IO.html#error/1","title":"Mix.Shell.IO.error/1","type":"function","doc":"Prints the given ANSI error to the shell followed by a newline."},{"ref":"Mix.Shell.IO.html#info/1","title":"Mix.Shell.IO.info/1","type":"function","doc":"Prints the given ANSI message to the shell followed by a newline."},{"ref":"Mix.Shell.IO.html#print_app/0","title":"Mix.Shell.IO.print_app/0","type":"function","doc":"Prints the current application to the shell if it was not printed yet."},{"ref":"Mix.Shell.IO.html#prompt/1","title":"Mix.Shell.IO.prompt/1","type":"function","doc":"Prints a message and prompts the user for input. Input will be consumed until Enter is pressed."},{"ref":"Mix.Shell.IO.html#yes?/1","title":"Mix.Shell.IO.yes?/1","type":"function","doc":"Prints a message and asks the user if they want to proceed. The user must press Enter or type one of &quot;y&quot;, &quot;yes&quot;, &quot;Y&quot;, &quot;YES&quot; or &quot;Yes&quot;."},{"ref":"Mix.Shell.Process.html","title":"Mix.Shell.Process","type":"module","doc":"Mix shell that uses the current process mailbox for communication. This module provides a Mix shell implementation that uses the current process mailbox for communication instead of IO. As an example, when Mix.shell.info(&quot;hello&quot;) is called, the following message will be sent to the calling process: {:mix_shell, :info, [&quot;hello&quot;]} This is mainly useful in tests, allowing us to assert if given messages were received or not instead of performing checks on some captured IO. Since we need to guarantee a clean slate between tests, there is also a flush/1 function responsible for flushing all :mix_shell related messages from the process inbox. Examples Mix.shell.info &quot;hello&quot; receive do {:mix_shell, :info, [msg]} -&gt; msg end #=&gt; &quot;hello&quot; send self(), {:mix_shell_input, :prompt, &quot;Pretty cool&quot;} Mix.shell.prompt?(&quot;How cool was that?!&quot;) #=&gt; &quot;Pretty cool&quot;"},{"ref":"Mix.Shell.Process.html#cmd/2","title":"Mix.Shell.Process.cmd/2","type":"function","doc":"Executes the given command and forwards its messages to the current process."},{"ref":"Mix.Shell.Process.html#error/1","title":"Mix.Shell.Process.error/1","type":"function","doc":"Forwards the error to the current process."},{"ref":"Mix.Shell.Process.html#flush/1","title":"Mix.Shell.Process.flush/1","type":"function","doc":"Flushes all :mix_shell and :mix_shell_input messages from the current process. If a callback is given, it is invoked for each received message. Examples flush &amp;IO.inspect(&amp;1)"},{"ref":"Mix.Shell.Process.html#info/1","title":"Mix.Shell.Process.info/1","type":"function","doc":"Forwards the message to the current process."},{"ref":"Mix.Shell.Process.html#print_app/0","title":"Mix.Shell.Process.print_app/0","type":"function","doc":"Prints the current application if it was not printed yet."},{"ref":"Mix.Shell.Process.html#prompt/1","title":"Mix.Shell.Process.prompt/1","type":"function","doc":"Forwards the message to the current process. It also checks the inbox for an input message matching: {:mix_shell_input, :prompt, value} If one does not exist, it will abort since there was no shell process inputs given. value must be a string. Examples The following will answer with &quot;Meg&quot; to the prompt &quot;What&#39;s your name?&quot;: # The response is sent before calling prompt/1 so that prompt/1 can read it send self(), {:mix_shell_input, :prompt, &quot;Meg&quot;} Mix.shell.prompt(&quot;What&#39;s your name?&quot;)"},{"ref":"Mix.Shell.Process.html#yes?/1","title":"Mix.Shell.Process.yes?/1","type":"function","doc":"Forwards the message to the current process. It also checks the inbox for an input message matching: {:mix_shell_input, :yes?, value} If one does not exist, it will abort since there was no shell process inputs given. value must be true or false. Example # Send the response to self() first so that yes?/1 will be able to read it send self(), {:mix_shell_input, :yes?, true} Mix.shell.yes?(&quot;Are you sure you want to continue?&quot;)"},{"ref":"Mix.Shell.Quiet.html","title":"Mix.Shell.Quiet","type":"module","doc":"This is Mix&#39;s default shell when the MIX_QUIET environment variable is set. It&#39;s just like Mix.Shell.IO, but prints far less."},{"ref":"Mix.Shell.Quiet.html#cmd/2","title":"Mix.Shell.Quiet.cmd/2","type":"function","doc":"Executes the given command quietly without outputting anything."},{"ref":"Mix.Shell.Quiet.html#error/1","title":"Mix.Shell.Quiet.error/1","type":"function","doc":"Prints the error to the shell followed by a newline."},{"ref":"Mix.Shell.Quiet.html#info/1","title":"Mix.Shell.Quiet.info/1","type":"function","doc":"Prints nothing to the shell."},{"ref":"Mix.Shell.Quiet.html#print_app/0","title":"Mix.Shell.Quiet.print_app/0","type":"function","doc":"Prints the current application if it was not printed yet."},{"ref":"Mix.Shell.Quiet.html#prompt/1","title":"Mix.Shell.Quiet.prompt/1","type":"function","doc":"Prints a message and prompts the user for input. Input will be consumed until Enter is pressed."},{"ref":"Mix.Shell.Quiet.html#yes?/1","title":"Mix.Shell.Quiet.yes?/1","type":"function","doc":"Prints a message and asks the user if they want to proceed. The user must press Enter or type one of &quot;y&quot;, &quot;yes&quot;, &quot;Y&quot;, &quot;YES&quot; or &quot;Yes&quot;."},{"ref":"Mix.Task.html","title":"Mix.Task","type":"behaviour","doc":"A simple module that provides conveniences for creating, loading and manipulating tasks. A Mix task can be defined by simply using Mix.Task in a module starting with Mix.Tasks. and defining the run/1 function: defmodule Mix.Tasks.Echo do use Mix.Task @impl Mix.Task def run(args) do Mix.shell.info Enum.join(args, &quot; &quot;) end end The run/1 function will receive a list of all arguments passed to the command line. Attributes There are a few attributes available in Mix tasks to configure them in Mix: @shortdoc - makes the task public with a short description that appears on mix help @recursive - runs the task recursively in umbrella projects @preferred_cli_env - recommends environment to run task. It is used in absence of a Mix project recommendation, or explicit MIX_ENV, and it only works for tasks in the current project. @preferred_cli_env is not loaded from dependencies as we need to know the environment before dependencies are loaded. Documentation Users can read the documentation for public Mix tasks by running mix help my_task. The documentation that will be shown is the @moduledoc of the task&#39;s module."},{"ref":"Mix.Task.html#alias?/1","title":"Mix.Task.alias?/1","type":"function","doc":"Checks if an alias called task exists. For more information about task aliasing, take a look at the &quot;Aliasing&quot; section in the docs for Mix."},{"ref":"Mix.Task.html#all_modules/0","title":"Mix.Task.all_modules/0","type":"function","doc":"Returns all loaded task modules. Modules that are not yet loaded won&#39;t show up. Check load_all/0 if you want to preload all tasks."},{"ref":"Mix.Task.html#clear/0","title":"Mix.Task.clear/0","type":"function","doc":"Clears all invoked tasks, allowing them to be reinvoked. This operation is not recursive."},{"ref":"Mix.Task.html#get/1","title":"Mix.Task.get/1","type":"function","doc":"Receives a task name and returns the task module if found. Otherwise returns nil in case the module exists, but it isn&#39;t a task or cannot be found."},{"ref":"Mix.Task.html#get!/1","title":"Mix.Task.get!/1","type":"function","doc":"Receives a task name and retrieves the task module. Exceptions Mix.NoTaskError - raised if the task could not be found Mix.InvalidTaskError - raised if the task is not a valid Mix.Task"},{"ref":"Mix.Task.html#load_all/0","title":"Mix.Task.load_all/0","type":"function","doc":"Loads all tasks in all code paths."},{"ref":"Mix.Task.html#load_tasks/1","title":"Mix.Task.load_tasks/1","type":"function","doc":"Loads all tasks in the given paths."},{"ref":"Mix.Task.html#moduledoc/1","title":"Mix.Task.moduledoc/1","type":"function","doc":"Gets the moduledoc for the given task module. Returns the moduledoc or nil."},{"ref":"Mix.Task.html#preferred_cli_env/1","title":"Mix.Task.preferred_cli_env/1","type":"function","doc":"Gets preferred CLI environment for the task. Returns environment (for example, :test, or :prod), or nil."},{"ref":"Mix.Task.html#recursing?/0","title":"Mix.Task.recursing?/0","type":"function","doc":"Indicates if the current task is recursing. This returns true if a task is marked as recursive and it is being executed inside an umbrella project."},{"ref":"Mix.Task.html#recursive/1","title":"Mix.Task.recursive/1","type":"function","doc":"Checks if the task should be run recursively for all sub-apps in umbrella projects. Returns true or false."},{"ref":"Mix.Task.html#reenable/1","title":"Mix.Task.reenable/1","type":"function","doc":"Reenables a given task so it can be executed again down the stack. Both alias and the regular stack are reenabled when this function is called. If an umbrella project reenables a task, it is reenabled for all child projects."},{"ref":"Mix.Task.html#rerun/2","title":"Mix.Task.rerun/2","type":"function","doc":"Reruns task with the given arguments. This function reruns the given task; to do that, it first re-enables the task and then runs it as normal."},{"ref":"Mix.Task.html#c:run/1","title":"Mix.Task.run/1","type":"callback","doc":"A task needs to implement run which receives a list of command line args."},{"ref":"Mix.Task.html#run/2","title":"Mix.Task.run/2","type":"function","doc":"Runs a task with the given args. If the task was not yet invoked, it runs the task and returns the result. If there is an alias with the same name, the alias will be invoked instead of the original task. If the task or alias were already invoked, it does not run them again and simply aborts with :noop. It may raise an exception if an alias or a task can&#39;t be found or the task is invalid. Check get!/1 for more information."},{"ref":"Mix.Task.html#shortdoc/1","title":"Mix.Task.shortdoc/1","type":"function","doc":"Gets the shortdoc for the given task module. Returns the shortdoc or nil."},{"ref":"Mix.Task.html#task?/1","title":"Mix.Task.task?/1","type":"function","doc":"Returns true if given module is a task."},{"ref":"Mix.Task.html#task_name/1","title":"Mix.Task.task_name/1","type":"function","doc":"Returns the task name for the given module."},{"ref":"Mix.Task.html#t:task_module/0","title":"Mix.Task.task_module/0","type":"type","doc":""},{"ref":"Mix.Task.html#t:task_name/0","title":"Mix.Task.task_name/0","type":"type","doc":""},{"ref":"Mix.Task.Compiler.html","title":"Mix.Task.Compiler","type":"behaviour","doc":"This module defines the behaviour for a Mix task that does compilation. A Mix compiler task can be defined by simply using Mix.Task.Compiler in a module whose name starts with Mix.Tasks.Compile. and defining the run/1 function: defmodule Mix.Tasks.Compile.MyLanguage do use Mix.Task.Compiler def run(_args) do :ok end end The run/1 function returns an atom indicating the status of the compilation, and optionally can also return a list of &quot;diagnostics&quot; such as warnings or compilation errors. Doing this enables code editors to display issues inline without having to analyze the command-line output. If the compiler uses manifest files to track stale sources, it should define manifests/0, and if it writes any output to disk it should also define clean/0. A compiler supports the same attributes for configuration and documentation as a regular Mix task. See Mix.Task for more information."},{"ref":"Mix.Task.Compiler.html#c:clean/0","title":"Mix.Task.Compiler.clean/0","type":"callback","doc":"Removes build artifacts and manifests."},{"ref":"Mix.Task.Compiler.html#c:manifests/0","title":"Mix.Task.Compiler.manifests/0","type":"callback","doc":"Lists manifest files for the compiler."},{"ref":"Mix.Task.Compiler.html#c:run/1","title":"Mix.Task.Compiler.run/1","type":"callback","doc":"Receives command-line arguments and performs compilation. If it produces errors, warnings, or any other diagnostic information, it should return a tuple with the status and a list of diagnostics."},{"ref":"Mix.Task.Compiler.Diagnostic.html","title":"Mix.Task.Compiler.Diagnostic","type":"module","doc":"Diagnostic information such as a warning or compilation error."},{"ref":"Mix.Task.Compiler.Diagnostic.html#t:position/0","title":"Mix.Task.Compiler.Diagnostic.position/0","type":"type","doc":"Where in a file the diagnostic applies. Can be either a line number, a range specified as {start_line, start_col, end_line, end_col}, or nil if unknown. Line numbers are one-based, and column numbers in a range are zero-based and refer to the cursor position at the start of the character at that index. For example, to indicate that a diagnostic applies to the first n characters of the first line, the range would be {1, 0, 1, n}."},{"ref":"Mix.Task.Compiler.Diagnostic.html#t:severity/0","title":"Mix.Task.Compiler.Diagnostic.severity/0","type":"type","doc":"Severity of a diagnostic: :error - An issue that caused compilation to fail :warning - An issue that did not cause failure but suggests the programmer may have made a mistake :hint - A suggestion for style or good practices that is not as severe as a warning :information - Any other information relevant to compilation that does not fit into the above categories"},{"ref":"Mix.Task.Compiler.Diagnostic.html#t:t/0","title":"Mix.Task.Compiler.Diagnostic.t/0","type":"type","doc":""},{"ref":"Mix.Tasks.App.Start.html","title":"Mix.Tasks.App.Start","type":"task","doc":"Starts all registered apps. The application is started by default as temporary. In case :start_permanent is set to true in your project configuration or the --permanent option is given, it is started as permanent, which guarantees the node will shut down if the application crashes permanently. Configuration :start_permanent - the application and all of its children applications are started in permanent mode. Defaults to false. :consolidate_protocols - when true, loads consolidated protocols before start. The default value is true. :elixir - matches the current Elixir version against the given requirement Command line options --force - forces compilation regardless of compilation times --temporary - starts the application as temporary --permanent - starts the application as permanent --preload-modules - preloads all modules defined in applications --no-compile - does not compile even if files require compilation --no-protocols - does not load consolidated protocols --no-archives-check - does not check archives --no-deps-check - does not check dependencies --no-elixir-version-check - does not check Elixir version --no-start - does not start applications after compilation"},{"ref":"Mix.Tasks.App.Tree.html","title":"Mix.Tasks.App.Tree","type":"task","doc":"Prints the application tree. mix app.tree --exclude logger --exclude elixir If no application is given, it uses the current application defined in the mix.exs file. Command line options --exclude - exclude applications which you do not want to see printed. kernel, stdlib and compiler are always excluded from the tree. --format - Can be set to one of either: pretty - uses Unicode codepoints for formatting the tree. This is the default except on Windows. plain - does not use Unicode codepoints for formatting the tree. This is the default on Windows. dot - produces a DOT graph description of the application tree in app_tree.dot in the current directory. Warning: this will overwrite any previously generated file."},{"ref":"Mix.Tasks.Archive.html","title":"Mix.Tasks.Archive","type":"task","doc":"Lists all installed archives. Archives are typically installed at ~/.mix/archives although the installation path can be customized by setting the MIX_ARCHIVES environment variable. Since archives are specific to Elixir versions, it is expected from build tools to swap the MIX_ARCHIVES variable to different locations based on a particular Elixir installation."},{"ref":"Mix.Tasks.Archive.Build.html","title":"Mix.Tasks.Archive.Build","type":"task","doc":"Builds an archive according to the specification of the Erlang Archive Format. Archives are meant to contain small projects, usually installed locally. Archives may be installed into a Mix environment by running mix archive.install. Once installed, the archive is available to all Mix projects. For this reason, the functionality behind archives is limited. For instance, archives do not include dependencies, as those would conflict with any dependency in a Mix project after the archive is installed. In general, we recommend the usage of archives to be limited for extensions of Mix, such as custom SCMs, package managers, etc. For general scripts to be distributed to developers, please see mix escript.build. The archive will be created in the current directory (which is expected to be the project root), unless an argument -o is provided with the file name. By default, this command archives the current project but the -i option can be used to archive any directory. For example, mix archive.build with no options translates to: mix archive.build -i _build/ENV/lib/APP -o APP-VERSION.ez Command line options -o - specifies output file name. If there is a mix.exs, defaults to &quot;APP-VERSION.ez&quot;. -i - specifies the input directory to archive. If there is a mix.exs, defaults to the current application build. --no-compile - skips compilation. Only applies when mix.exs is available. --include-dot-files - adds dot files from priv directory to the archive."},{"ref":"Mix.Tasks.Archive.Check.html","title":"Mix.Tasks.Archive.Check","type":"task","doc":"Checks all archives are available. Mix projects can specify required archives using the :archives option: archives: [{:foo, &quot;~&gt; 1.0.0&quot;}] This task guarantees this option is respected."},{"ref":"Mix.Tasks.Archive.Install.html","title":"Mix.Tasks.Archive.Install","type":"task","doc":"Installs an archive locally. If no argument is supplied but there is an archive in the project&#39;s root directory (created with mix archive.build), then the archive will be installed locally. For example: mix do archive.build, archive.install If an argument is provided, it should be a local path or a URL to a prebuilt archive, a Git repository, a GitHub repository, or a Hex package. mix archive.install archive.ez mix archive.install path/to/archive.ez mix archive.install https://example.com/my_archive.ez mix archive.install git https://path/to/git/repo mix archive.install git https://path/to/git/repo branch git_branch mix archive.install git https://path/to/git/repo tag git_tag mix archive.install git https://path/to/git/repo ref git_ref mix archive.install github user/project mix archive.install github user/project branch git_branch mix archive.install github user/project tag git_tag mix archive.install github user/project ref git_ref mix archive.install hex hex_package mix archive.install hex hex_package 1.2.3 After installation, the tasks in the archive are available locally: mix some_task Note that installing via Git, GitHub, or Hex fetches the source of the archive and builds it, while using a URL or a local path fetches a pre-built archive. Command line options --sha512 - checks the archive matches the given SHA-512 checksum. Only applies to installations via URL or local path --force - forces installation without a shell prompt; primarily intended for automation in build systems like Make --submodules - fetches repository submodules before building archive from Git or GitHub --app - specifies a custom app name to be used for building the archive from Git, GitHub, or Hex --organization - specifies an organization to use if fetching the package from a private Hex repository --timeout - sets a request timeout in milliseconds for fetching archives from URLs. Default is 60 seconds"},{"ref":"Mix.Tasks.Archive.Uninstall.html","title":"Mix.Tasks.Archive.Uninstall","type":"task","doc":"Uninstalls local archives. mix archive.uninstall archive.ez Command line options --force - forces uninstallation without a shell prompt; primarily intended for automation"},{"ref":"Mix.Tasks.Clean.html","title":"Mix.Tasks.Clean","type":"task","doc":"Deletes generated application files. This command deletes all build artifacts for the current project. Dependencies&#39; sources and build files are cleaned only if the --deps option is given. By default this task works across all environments, unless --only is given."},{"ref":"Mix.Tasks.Cmd.html","title":"Mix.Tasks.Cmd","type":"task","doc":"Executes the given command. Useful in umbrella applications to execute a command on each child app: mix cmd echo pwd You can limit which apps the cmd runs in by passing the app names before the cmd using --app: mix cmd --app app1 --app app2 echo pwd Aborts when a command exits with a non-zero status. This task is automatically reenabled, so it can be called multiple times with different arguments. Zombie OS processes Beware that the Erlang VM does not terminate child processes when it shuts down. Therefore, if you use mix cmd to start long running processes and then shut down the VM, it is likely that those child processes won&#39;t be terminated with the VM. A solution is to make sure the child processes listen to the standard input and terminate when standard input is closed. We discuss this topic at length in the &quot;Zombie OS processes&quot; of the Port module documentation."},{"ref":"Mix.Tasks.Compile.html","title":"Mix.Tasks.Compile","type":"task","doc":"A meta task that compiles source files. It simply runs the compilers registered in your project and returns a tuple with the compilation status and a list of diagnostics. Configuration :compilers - compilers to run, defaults to Mix.compilers/0, which are [:yecc, :leex, :erlang, :elixir, :xref, :app]. :consolidate_protocols - when true, runs protocol consolidation via the compile.protocols task. The default value is true. :build_embedded - when true, embeds all code and priv content in the _build directory instead of using symlinks. :build_path - the directory where build artifacts should be written to. This option is intended only for child apps within a larger umbrella application so that each child app can use the common _build directory of the parent umbrella. In a non-umbrella context, configuring this has undesirable side-effects (such as skipping some compiler checks) and should be avoided. Compilers To see documentation for each specific compiler, you must invoke help directly for the compiler command: mix help compile.elixir mix help compile.erlang You can get a list of all compilers by running: mix compile --list Command line options --list - lists all enabled compilers --no-archives-check - skips checking of archives --no-deps-check - skips checking of dependencies --no-protocol-consolidation - skips protocol consolidation --force - forces compilation --return-errors - returns error status and diagnostics instead of exiting on error --erl-config - path to an Erlang term file that will be loaded as Mix config"},{"ref":"Mix.Tasks.Compile.html#compilers/0","title":"Mix.Tasks.Compile.compilers/0","type":"function","doc":"Returns all compilers."},{"ref":"Mix.Tasks.Compile.App.html","title":"Mix.Tasks.Compile.App","type":"task","doc":"Writes an .app file. An .app file is a file containing Erlang terms that defines your application. Mix automatically generates this file based on your mix.exs configuration. In order to generate the .app file, Mix expects your project to have both :app and :version keys. Furthermore, you can configure the generated application by defining an application/0 function in your mix.exs that returns a keyword list. The most commonly used keys are: :extra_applications - a list of OTP applications your application depends on which are not included in :deps (usually defined in deps/0 in your mix.exs). For example, here you can declare a dependency on applications that ship with Erlang/OTP or Elixir, like :crypto or :logger, but anything in the code path works. Mix guarantees that these applications and the rest of your runtime dependencies are started before your application starts. :registered - the name of all registered processes in the application. If your application defines a local GenServer with name MyServer, it is recommended to add MyServer to this list. It is most useful in detecting conflicts between applications that register the same names. :env - the default values for the application environment. The application environment is one of the most common ways to configure applications. See the Application module for mechanisms to read and write to the application environment. For example: def application do [extra_applications: [:logger, :crypto], env: [key: :value], registered: [MyServer]] end Other options include: :applications - all applications your application depends on at runtime. By default, this list is automatically inferred from your dependencies. Mix and other tools use the application list in order to start your dependencies before starting the application itself. :mod - specifies a module to invoke when the application is started. It must be in the format {Mod, args} where args is often an empty list. The module specified must implement the callbacks defined by the Application module. :start_phases - specifies a list of phases and their arguments to be called after the application is started. See the &quot;Phases&quot; section below. :included_applications - specifies a list of applications that will be included in the application. It is the responsibility of the primary application to start the supervision tree of all included applications, as only the primary application will be started. A process in an included application considers itself belonging to the primary application. :maxT - specifies the maximum time the application is allowed to run, in milliseconds. Applications are stopped if :maxT is reached, and their top-level supervisor terminated with reason :normal. This threshold is technically valid in any resource file, but it is only effective for applications with a callback module. Defaults to :infinity. Besides the options above, .app files also expect other options like :modules and :vsn, but these are automatically added by Mix. Command line options --force - forces compilation regardless of modification times --compile-path - where to find .beam files and write the resulting .app file, defaults to Mix.Project.compile_path/0 Phases Applications provide a start phases mechanism which will be called, in order, for the application and all included applications. If a phase is not defined for an included application, that application is skipped. Let&#39;s see an example MyApp.application/0 function: def application do [start_phases: [init: [], go: [], finish: []], included_applications: [:my_included_app]] end And an example :my_included_app defines on its mix.exs the function: def application do [mod: {MyIncludedApp, []}, start_phases: [go: []]] end In this example, the order that the application callbacks are called in is: Application.start(MyApp) MyApp.start(:normal, []) MyApp.start_phase(:init, :normal, []) MyApp.start_phase(:go, :normal, []) MyIncludedApp.start_phase(:go, :normal, []) MyApp.start_phase(:finish, :normal, [])"},{"ref":"Mix.Tasks.Compile.Elixir.html","title":"Mix.Tasks.Compile.Elixir","type":"task","doc":"Compiles Elixir source files. Elixir is smart enough to recompile only files that have changed and their dependencies. This means if lib/a.ex is invoking a function defined over lib/b.ex, whenever lib/b.ex changes, lib/a.ex is also recompiled. Note it is important to recompile a file&#39;s dependencies as there are often compile time dependencies between them. Command line options --force - forces compilation regardless of modification times --docs (--no-docs) - attaches (or not) documentation to compiled modules --debug-info (--no-debug-info) - attaches (or not) debug info to compiled modules --ignore-module-conflict - does not emit warnings if a module was previously defined --warnings-as-errors - treats warnings in the current project as errors and return a non-zero exit code --long-compilation-threshold N - sets the &quot;long compilation&quot; threshold (in seconds) to N (see the docs for Kernel.ParallelCompiler.compile/2) --all-warnings - prints warnings even from files that do not need to be recompiled Configuration :elixirc_paths - directories to find source files. Defaults to [&quot;lib&quot;]. :elixirc_options - compilation options that apply to Elixir&#39;s compiler, they are: :ignore_module_conflict, :docs and :debug_info. By default, uses the same defaults as elixirc and they can always be overridden from the command line according to the options above."},{"ref":"Mix.Tasks.Compile.Erlang.html","title":"Mix.Tasks.Compile.Erlang","type":"task","doc":"Compiles Erlang source files. When this task runs, it will first check the modification times of all files to be compiled and if they haven&#39;t been changed since the last compilation, it will not compile them. If any of them have changed, it compiles everything. For this reason, the task touches your :compile_path directory and sets the modification time to the current time and date at the end of each compilation. You can force compilation regardless of modification times by passing the --force option. Command line options --force - forces compilation regardless of modification times --all-warnings - prints warnings even from files that do not need to be recompiled Configuration ERL_COMPILER_OPTIONS - can be used to give default compile options. The value must be a valid Erlang term. If the value is a list, it will be used as is. If it is not a list, it will be put into a list. :erlc_paths - directories to find source files. Defaults to [&quot;src&quot;]. :erlc_include_path - directory for adding include files. Defaults to &quot;include&quot;. :erlc_options - compilation options that apply to Erlang&#39;s compiler. Defaults to [:debug_info]. For a complete list of options, see :compile.file/2. For example, to configure the erlc_options for your Erlang project you may run: erlc_options: [:debug_info, {:i, &#39;path/to/include&#39;}]"},{"ref":"Mix.Tasks.Compile.Leex.html","title":"Mix.Tasks.Compile.Leex","type":"task","doc":"Compiles Leex source files. When this task runs, it will check the modification time of every file, and if it has changed, the file will be compiled. Files will be compiled in the same source directory with a .erl extension. You can force compilation regardless of modification times by passing the --force option. Command line options --force - forces compilation regardless of modification times --all-warnings - prints warnings even from files that do not need to be recompiled Configuration :erlc_paths - directories to find source files. Defaults to [&quot;src&quot;]. :leex_options - compilation options that apply to Leex&#39;s compiler. For a complete list of options, see :leex.file/2. Note that the :report, :return_errors, and :return_warnings options are overridden by this compiler, thus setting them has no effect."},{"ref":"Mix.Tasks.Compile.Protocols.html","title":"Mix.Tasks.Compile.Protocols","type":"task","doc":"Consolidates all protocols in all paths. This task is automatically invoked unless the project disables the :consolidate_protocols option in their configuration. Consolidation Protocol consolidation is useful in production when no dynamic code loading will happen, effectively optimizing protocol dispatches by not accounting for code loading. This task consolidates all protocols in the code path and outputs the new binary files to the given directory. Defaults to &quot;_build/MIX_ENV/lib/YOUR_APP/consolidated&quot; for regular apps and &quot;_build/MIX_ENV/consolidated&quot; in umbrella projects. In case you are manually compiling protocols or building releases, you need to take the generated protocols into account. This can be done with: $ elixir -pa _build/MIX_ENV/lib/YOUR_APP/consolidated -S mix run Or in umbrellas: $ elixir -pa _build/MIX_ENV/consolidated -S mix run You can verify a protocol is consolidated by checking its attributes: iex&gt; Protocol.consolidated?(Enumerable) true"},{"ref":"Mix.Tasks.Compile.Protocols.html#consolidated?/0","title":"Mix.Tasks.Compile.Protocols.consolidated?/0","type":"function","doc":"Returns if protocols have been consolidated at least once."},{"ref":"Mix.Tasks.Compile.Xref.html","title":"Mix.Tasks.Compile.Xref","type":"task","doc":"Performs remote dispatch checking. It uses mix xref to check if any remote call does not exist or is deprecated, and emits a warnings in such cases. This tasks does not show deprecated local calls (a call to a deprecated function or macro in the same module) nor calls to deprecated functionality in Elixir itself. When this task runs, it will check if the source code has been modified. If it has changed, mix xref will be run to check remote dispatches. You can force checking regardless of modification time by passing the --force option. Command line options --force - forces checking regardless of modification time --warnings-as-errors - treats warnings as errors and returns a non-zero exit code"},{"ref":"Mix.Tasks.Compile.Yecc.html","title":"Mix.Tasks.Compile.Yecc","type":"task","doc":"Compiles Yecc source files. When this task runs, it will check the modification time of every file, and if it has changed, the file will be compiled. Files will be compiled in the same source directory with a .erl extension. You can force compilation regardless of modification times by passing the --force option. Command line options --force - forces compilation regardless of modification times --all-warnings - prints warnings even from files that do not need to be recompiled Configuration :erlc_paths - directories to find source files. Defaults to [&quot;src&quot;]. :yecc_options - compilation options that apply to Yecc&#39;s compiler. For a complete list of options, see :yecc.file/1. Note that the :report, :return_errors, and :return_warnings options are overridden by this compiler, thus setting them has no effect."},{"ref":"Mix.Tasks.Deps.html","title":"Mix.Tasks.Deps","type":"task","doc":"Lists all dependencies and their status. Dependencies must be specified in the mix.exs file in one of the following formats: {app, requirement} {app, opts} {app, requirement, opts} Where: app is an atom requirement is a Version requirement or a regular expression opts is a keyword list of options For example: {:plug, &quot;&gt;= 0.4.0&quot;} {:gettext, git: &quot;https://github.com/elixir-lang/gettext.git&quot;, tag: &quot;0.1&quot;} {:local_dependency, path: &quot;path/to/local_dependency&quot;} By default, dependencies are fetched using the Hex package manager: {:plug, &quot;&gt;= 0.4.0&quot;} By specifying such dependencies, Mix will automatically install Hex (if it wasn&#39;t previously installed) and download a package suitable to your project. Mix also supports Git and path dependencies: {:foobar, git: &quot;https://github.com/elixir-lang/foobar.git&quot;, tag: &quot;0.1&quot;} {:foobar, path: &quot;path/to/foobar&quot;} And also in umbrella dependencies: {:my_app, in_umbrella: true} Path and in umbrella dependencies are automatically recompiled by the parent project whenever they change. While fetchable dependencies, like the ones using :git, are recompiled only when fetched/updated. The dependencies&#39; versions are expected to be formatted according to Semantic Versioning and the requirements must be specified as defined in the Version module. Options Below we provide a more detailed look into the available options. Dependency definition options :app - when set to false, does not read the app file for this dependency. By default, the app file is read :env - the environment (as an atom) to run the dependency on; defaults to :prod :compile - a command (string) to compile the dependency; defaults to a mix, rebar or make command :optional - marks the dependency as optional. In such cases, the current project will always include the optional dependency but any other project that depends on the current project won&#39;t be forced to use the optional dependency. However, if the other project includes the optional dependency on its own, the requirements and options specified here will also be applied. :only - the dependency is made available only in the given environments, useful when declaring dev- or test-only dependencies; by default the dependency will be available in all environments. The value of this option can either be a single environment (like :dev) or a list of environments (like [:dev, :test]) :targets - the dependency is made available only for the given targets. By default the dependency will be available in all environments. The value of this option can either be a single target (like :host) or a list of environments (like [:host, :rpi3]). This option is experimental and it may change behaviour or be removed in future releases. :override - if set to true the dependency will override any other definitions of itself by other dependencies :manager - Mix can also compile Rebar, Rebar3 and makefile projects and can fetch sub dependencies of Rebar and Rebar3 projects. Mix will try to infer the type of project but it can be overridden with this option by setting it to :mix, :rebar3, :rebar or :make. In case there are conflicting definitions, the first manager in the list above will be picked up. For example, if a dependency is found with :rebar3 and :rebar managers in different part of the trees, :rebar3 will be automatically picked. You can find the manager by running mix deps and override it by setting the :override option in a top-level project. :runtime - whether the dependency is part of runtime applications. If the :applications key is not provided in def application in your mix.exs file, Mix will automatically include all dependencies as a runtime application, except if runtime: false is given. Defaults to true. :system_env - an enumerable of key-value tuples of binaries to be set as environment variables when loading or compiling the dependency Git options (:git) :git - the Git repository URI :github - a shortcut for specifying Git repos from GitHub, uses :git :ref - the reference to checkout (may be a branch, a commit SHA or a tag) :branch - the Git branch to checkout :tag - the Git tag to checkout :submodules - when true, initialize submodules for the repo :sparse - checkout a single directory inside the Git repository and use it as your Mix dependency. Search &quot;sparse git checkouts&quot; for more information. If your Git repository requires authentication, such as basic username:password HTTP authentication via URLs, it can be achieved via Git configuration, keeping the access rules outside of source control. git config --global url.&quot;https://YOUR_USER:YOUR_PASS@example.com/&quot;.insteadOf &quot;https://example.com/&quot; For more information, see the git config documentation: https://git-scm.com/docs/git-config#git-config-urlltbasegtinsteadOf Path options (:path) :path - the path for the dependency :in_umbrella - when true, sets a path dependency pointing to &quot;../\#{app}&quot;, sharing the same environment as the current application Hex options (:hex) See the Hex usage documentation for Hex options. Deps task mix deps task lists all dependencies in the following format: APP VERSION (SCM) (MANAGER) [locked at REF] STATUS It supports the following options: --all - lists all dependencies, regardless of specified environment"},{"ref":"Mix.Tasks.Deps.Clean.html","title":"Mix.Tasks.Deps.Clean","type":"task","doc":"Deletes the given dependencies&#39; files, including build artifacts and fetched sources. Since this is a destructive action, cleaning of dependencies only occurs when passing arguments/options: dep1 dep2 - the names of dependencies to be deleted separated by a space --unlock - also unlocks the deleted dependencies --build - deletes only compiled files (keeps source files) --all - deletes all dependencies --unused - deletes only unused dependencies (i.e. dependencies no longer mentioned in mix.exs) By default this task works across all environments, unless --only is given which will clean all dependencies leaving only the ones for chosen environment."},{"ref":"Mix.Tasks.Deps.Compile.html","title":"Mix.Tasks.Deps.Compile","type":"task","doc":"Compiles dependencies. By default, compile all dependencies. A list of dependencies can be given to compile multiple dependencies in order. This task attempts to detect if the project contains one of the following files and act accordingly: mix.exs - invokes mix compile rebar.config - invokes rebar compile Makefile.win - invokes nmake /F Makefile.win (only on Windows) Makefile - invokes gmake on FreeBSD and OpenBSD, invokes make on any other OS (except on Windows) The compilation can be customized by passing a compile option in the dependency: {:some_dependency, &quot;0.1.0&quot;, compile: &quot;command to compile&quot;} If a list of dependencies is given, Mix will attempt to compile them as is. For example, if project a depends on b, calling mix deps.compile a will compile a even if b is out of date. This is to allow parts of the dependency tree to be recompiled without propagating those changes upstream. To ensure b is included in the compilation step, pass --include-children."},{"ref":"Mix.Tasks.Deps.Get.html","title":"Mix.Tasks.Deps.Get","type":"task","doc":"Gets all out of date dependencies, i.e. dependencies that are not available or have an invalid lock. Command line options --only - only fetches dependencies for given environment --no-archives-check - does not check archives before fetching deps"},{"ref":"Mix.Tasks.Deps.Loadpaths.html","title":"Mix.Tasks.Deps.Loadpaths","type":"task","doc":"Checks and loads all dependencies along the way. If there is an invalid dependency, its status is printed before aborting. Although this task does not show up in mix help, it is part of Mix public API and can be depended on. Command line options --no-deps-check - does not check or compile deps, only load available ones --no-compile - does not compile dependencies --no-load-deps - do not load deps from the code path"},{"ref":"Mix.Tasks.Deps.Precompile.html","title":"Mix.Tasks.Deps.Precompile","type":"task","doc":"Extension point for precompiling dependencies. This is a task that can be aliased by projects that need to execute certain tasks before compiling dependencies: aliases: [&quot;deps.precompile&quot;: [&quot;nerves.precompile&quot;, &quot;deps.precompile&quot;]] By default, this task&#39;s single responsibility is to load all dependency paths. Dependency loading is deliberately ad-hoc, loading as much as possible without validating the files."},{"ref":"Mix.Tasks.Deps.Tree.html","title":"Mix.Tasks.Deps.Tree","type":"task","doc":"Prints the dependency tree. mix deps.tree If no dependency is given, it uses the tree defined in the mix.exs file. Command line options --only - the environment to show dependencies for --target - the target to show dependencies for --exclude - exclude dependencies which you do not want to see printed. --format - Can be set to one of either: pretty - uses Unicode codepoints for formatting the tree. This is the default except on Windows. plain - does not use Unicode codepoints for formatting the tree. This is the default on Windows. dot - produces a DOT graph description of the dependency tree in deps_tree.dot in the current directory. Warning: this will override any previously generated file."},{"ref":"Mix.Tasks.Deps.Unlock.html","title":"Mix.Tasks.Deps.Unlock","type":"task","doc":"Unlocks the given dependencies. Since this is a destructive action, unlocking dependencies only occurs when passing arguments/options: dep1 dep2 - the name of dependencies to be unlocked --all - unlocks all dependencies --unused - unlocks only unused dependencies (no longer mentioned in the mix.exs file)"},{"ref":"Mix.Tasks.Deps.Update.html","title":"Mix.Tasks.Deps.Update","type":"task","doc":"Updates the given dependencies. The given dependencies and the projects they depend on will be unlocked and updated to the latest version according to their version requirements. Since this is a destructive action, updating all dependencies only occurs when the --all command line option is passed. All dependencies are automatically recompiled after update. mix deps.unlock + mix deps.get Upgrading a dependency often requires the projects it depends on to upgrade too. If you would rather update a single dependency and not touch its children, you can explicitly unlock the single dependency and run mix deps.get: $ mix deps.unlock some_dep $ mix deps.get Command line options --all - updates all dependencies --only - only fetches dependencies for given environment --target - only fetches dependencies for given target --no-archives-check - does not check archives before fetching deps"},{"ref":"Mix.Tasks.Do.html","title":"Mix.Tasks.Do","type":"task","doc":"Executes the tasks separated by comma. The comma should be followed by a space. This task is automatically reenabled, so it can be called multiple times. Examples The example below prints the available compilers and then the list of dependencies. mix do compile --list, deps"},{"ref":"Mix.Tasks.Escript.html","title":"Mix.Tasks.Escript","type":"task","doc":"Lists all installed escripts. Escripts are installed at ~/.mix/escripts. Add that path to your PATH environment variable to be able to run installed escripts from any directory."},{"ref":"Mix.Tasks.Escript.Build.html","title":"Mix.Tasks.Escript.Build","type":"task","doc":"Builds an escript for the project. An escript is an executable that can be invoked from the command line. An escript can run on any machine that has Erlang/OTP installed and by default does not require Elixir to be installed, as Elixir is embedded as part of the escript. This task guarantees the project and its dependencies are compiled and packages them inside an escript. Before invoking mix escript.build, it is only necessary to define a :escript key with a :main_module option in your mix.exs file: escript: [main_module: MyApp.CLI] Escripts should be used as a mechanism to share scripts between developers and not as a deployment mechanism. For running live systems, consider using mix run or building releases. See the Application module for more information on systems life- cycles. By default, this task starts the current application. If this is not desired, set the :app configuration to nil. This task also removes documentation and debugging chunks from the compiled .beam files to reduce the size of the escript. If this is not desired, check the :strip_beams option. Note: escripts do not support projects and dependencies that need to store or read artifacts from the priv directory. Command line options Expects the same command line options as mix compile. Configuration The following option must be specified in your mix.exs under :escript key: :main_module - the module to be invoked once the escript starts. The module must contain a function named main/1 that will receive the command line arguments as binaries. The remaining options can be specified to further customize the escript: :name - the name of the generated escript. Defaults to app name. :path - the path to write the escript to. Defaults to app name. :app - the app that starts with the escript. Defaults to app name. Set it to nil if no application should be started. :strip_beam - if true strips BEAM code in the escript to remove chunks unnecessary at runtime, such as debug information and documentation. Defaults to true. :embed_elixir - if true embeds Elixir and its children apps (ex_unit, mix, etc.) mentioned in the :applications list inside the application/0 function in mix.exs. Defaults to true for Elixir projects, false for Erlang projects. Note: if you set this to false for an Elixir project, you will have to add paths to Elixir&#39;s ebin directories to ERL_LIBS environment variable when running the resulting escript, in order for the code loader to be able to find :elixir application and its children applications (if they are used). :shebang - shebang interpreter directive used to execute the escript. Defaults to &quot;#! /usr/bin/env escript\\n&quot;. :comment - comment line to follow shebang directive in the escript. Defaults to &quot;&quot;. :emu_args - emulator arguments to embed in the escript file. Defaults to &quot;&quot;. There is one project-level option that affects how the escript is generated: language: :elixir | :erlang - set it to :erlang for Erlang projects managed by Mix. Doing so will ensure Elixir is not embedded by default. Your app will still be started as part of escript loading, with the config used during build. Example defmodule MyApp.MixProject do use Mix.Project def project do [ app: :my_app, version: &quot;0.0.1&quot;, escript: escript() ] end def escript do [main_module: MyApp.CLI] end end defmodule MyApp.CLI do def main(_args) do IO.puts(&quot;Hello from MyApp!&quot;) end end"},{"ref":"Mix.Tasks.Escript.Install.html","title":"Mix.Tasks.Escript.Install","type":"task","doc":"Installs an escript locally. If no argument is supplied but there is an escript in the project&#39;s root directory (created with mix escript.build), then the escript will be installed locally. For example: mix do escript.build, escript.install If an argument is provided, it should be a local path or a URL to a prebuilt escript, a Git repository, a GitHub repository, or a Hex package. mix escript.install escript mix escript.install path/to/escript mix escript.install https://example.com/my_escript mix escript.install git https://path/to/git/repo mix escript.install git https://path/to/git/repo branch git_branch mix escript.install git https://path/to/git/repo tag git_tag mix escript.install git https://path/to/git/repo ref git_ref mix escript.install github user/project mix escript.install github user/project branch git_branch mix escript.install github user/project tag git_tag mix escript.install github user/project ref git_ref mix escript.install hex hex_package mix escript.install hex hex_package 1.2.3 After installation, the escript can be invoked as ~/.mix/escripts/foo For convenience, consider adding ~/.mix/escripts directory to your PATH environment variable. For more information, check the wikipedia article on PATH: https://en.wikipedia.org/wiki/PATH_(variable) Command line options --sha512 - checks the escript matches the given SHA-512 checksum. Only applies to installations via URL or local path --force - forces installation without a shell prompt; primarily intended for automation in build systems like Make --submodules - fetches repository submodules before building escript from Git or GitHub --app - specifies a custom app name to be used for building the escript from Git, GitHub, or Hex --organization - specifies an organization to use if fetching the package from a private Hex repository --timeout - sets a request timeout in milliseconds for fetching archives from URLs. Default is 60 seconds"},{"ref":"Mix.Tasks.Escript.Uninstall.html","title":"Mix.Tasks.Escript.Uninstall","type":"task","doc":"Uninstalls local escripts: mix escript.uninstall escript_name Command line options --force - forces uninstallation without a shell prompt; primarily intended for automation"},{"ref":"Mix.Tasks.Format.html","title":"Mix.Tasks.Format","type":"task","doc":"Formats the given files and patterns. mix format mix.exs &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot; If any of the files is -, then the output is read from stdin and written to stdout. Formatting options The formatter will read a .formatter.exs in the current directory for formatter configuration. Evaluating this file should return a keyword list. Here is an example .formatter.exs that works as a starting point: [ inputs: [&quot;{mix,.formatter}.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;] ] Besides the options listed in Code.format_string!/2, the .formatter.exs supports the following options: :inputs (a list of paths and patterns) - specifies the default inputs to be used by this task. For example, [&quot;mix.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;]. Patterns are expanded with Path.wildcard/2. :subdirectories (a list of paths and patterns) - specifies subdirectories that have their own formatting rules. Each subdirectory should have a .formatter.exs that configures how entries in that subdirectory should be formatted as. Configuration between .formatter.exs are not shared nor inherited. If a .formatter.exs lists &quot;lib/app&quot; as a subdirectory, the rules in .formatter.exs won&#39;t be available in lib/app/.formatter.exs. Note that the parent .formatter.exs must not specify files inside the &quot;lib/app&quot; subdirectory in its :inputs configuration. If this happens, the behaviour of which formatter configuration will be picked is unspecified. :import_deps (a list of dependencies as atoms) - specifies a list of dependencies whose formatter configuration will be imported. When specified, the formatter should run in the same directory as the mix.exs file that defines those dependencies. See the &quot;Importing dependencies configuration&quot; section below for more information. :export (a keyword list) - specifies formatter configuration to be exported. See the &quot;Importing dependencies configuration&quot; section below. Task-specific options --check-formatted - checks that the file is already formatted. This is useful in pre-commit hooks and CI scripts if you want to reject contributions with unformatted code. However keep in mind that the formatted output may differ between Elixir versions as improvements and fixes are applied to the formatter. --check-equivalent - checks if the files after formatting have the same AST as before formatting. If the ASTs are not equivalent, it is a bug in the code formatter. This option is useful if you suspect you have ran into a formatter bug and you would like confirmation. --dry-run - does not save files after formatting. --dot-formatter - path to the file with formatter configuration. Defaults to .formatter.exs if one is available. See the &quot;.formatter.exs&quot; section for more information. If any of the --check-* options are given and a check fails, the formatted contents won&#39;t be written to disk nor printed to standard output. When to format code We recommend developers to format code directly in their editors, either automatically when saving a file or via an explicit command or key binding. If such option is not yet available in your editor of choice, adding the required integration is usually a matter of invoking: cd $project &amp;&amp; mix format $file where $file refers to the current file and $project is the root of your project. It is also possible to format code across the whole project by passing a list of patterns and files to mix format, as shown at the top of this task documentation. This list can also be set in the .formatter.exs under the :inputs key. Importing dependencies configuration This task supports importing formatter configuration from dependencies. A dependency that wants to export formatter configuration needs to have a .formatter.exs file at the root of the project. In this file, the dependency can export a :export option with configuration to export. For now, only one option is supported under :export: :locals_without_parens (whose value has the same shape as the value of the :locals_without_parens in Code.format_string!/2). The functions listed under :locals_without_parens in the :export option of a dependency can be imported in a project by listing that dependency in the :import_deps option of the formatter configuration file of the project. For example, consider I have a project my_app that depends on my_dep. my_dep wants to export some configuration, so my_dep/.formatter.exs would look like this: # my_dep/.formatter.exs [ # Regular formatter configuration for my_dep # ... export: [ locals_without_parens: [some_dsl_call: 2, some_dsl_call: 3] ] ] In order to import configuration, my_app&#39;s .formatter.exs would look like this: # my_app/.formatter.exs [ import_deps: [:my_dep] ]"},{"ref":"Mix.Tasks.Format.html#formatter_opts_for_file/2","title":"Mix.Tasks.Format.formatter_opts_for_file/2","type":"function","doc":"Returns formatter options to be used for the given file."},{"ref":"Mix.Tasks.Format.html#read_manifest/1","title":"Mix.Tasks.Format.read_manifest/1","type":"function","doc":""},{"ref":"Mix.Tasks.Help.html","title":"Mix.Tasks.Help","type":"task","doc":"Lists all tasks and aliases or prints the documentation for a given task or alias. Arguments mix help - prints all aliases, tasks and their short descriptions mix help ALIAS - prints the definition for the given alias mix help TASK - prints full docs for the given task mix help --search PATTERN - prints all tasks and aliases that contain PATTERN in the name mix help --names - prints all task names and aliases (useful for autocompleting) Colors When possible, mix help is going to use coloring for formatting guides. The formatting can be customized by configuring the Mix application either inside your project (in config/config.exs) or by using the local config (in ~/.mix/config.exs). For example, to disable color, one may use the configuration: [mix: [colors: [enabled: false]]] The available color options are: :enabled - shows ANSI formatting (defaults to IO.ANSI.enabled?/0) :doc_code - the attributes for code blocks (cyan, bright) :doc_inline_code - inline code (cyan) :doc_headings - h1 and h2 (yellow, bright) :doc_title - the overall heading for the output (reverse, yellow, bright) :doc_bold - (bright) :doc_underline - (underline)"},{"ref":"Mix.Tasks.Iex.html","title":"Mix.Tasks.Iex","type":"task","doc":"A task that simply instructs users to run iex -S mix."},{"ref":"Mix.Tasks.Loadconfig.html","title":"Mix.Tasks.Loadconfig","type":"task","doc":"Loads and persists the given configuration. If no configuration file is given, it loads the project&#39;s configuration file, &quot;config/config.exs&quot;, if it exists. Keep in mind that the &quot;config/config.exs&quot; file is always loaded by the CLI and invoking it is only required in cases you are starting Mix manually. This task is automatically reenabled, so it can be called multiple times to load different configs."},{"ref":"Mix.Tasks.Loadpaths.html","title":"Mix.Tasks.Loadpaths","type":"task","doc":"Loads the application and its dependencies paths. Configuration :elixir - matches the current Elixir version against the given requirement Command line options --no-archives-check - does not check archive --no-deps-check - does not check dependencies --no-elixir-version-check - does not check Elixir version"},{"ref":"Mix.Tasks.Local.html","title":"Mix.Tasks.Local","type":"task","doc":"Lists local tasks."},{"ref":"Mix.Tasks.Local.Hex.html","title":"Mix.Tasks.Local.Hex","type":"task","doc":"Installs Hex locally. mix local.hex Command line options --force - forces installation without a shell prompt; primarily intended for automation in build systems like make --if-missing - performs installation only if Hex is not installed yet; intended to avoid repeatedly reinstalling Hex in automation when a script may be run multiple times If both options are set, --force takes precedence. Mirrors If you want to change the default mirror used for fetching Hex, set the HEX_MIRROR environment variable."},{"ref":"Mix.Tasks.Local.PublicKeys.html","title":"Mix.Tasks.Local.PublicKeys","type":"task","doc":"Public keys are used by Mix to install packages like Rebar and Hex. Mix by default ships with a public key but new ones can be added on demand. To list all available keys: $ mix local.public_keys To list all available keys showing the keys themselves: $ mix local.public_keys --detailed To add a new key: $ mix local.public_keys local/path/to/key Be careful when adding new keys. Only add keys from sources you trust. Public keys are by default stored in your MIX_HOME under the public_keys directory. Command line options --force - forces installation without a shell prompt; primarily intended for automation in build systems like make"},{"ref":"Mix.Tasks.Local.Rebar.html","title":"Mix.Tasks.Local.Rebar","type":"task","doc":"Fetches a copy of rebar or rebar3 from the given path or URL. It defaults to safely download a Rebar copy from Hex&#39;s CDN. However, a URL can be given as argument, usually for an existing local copy of Rebar: mix local.rebar rebar path/to/rebar mix local.rebar rebar3 path/to/rebar If neither rebar or rebar3 are specified, both versions will be fetched. The local copy is stored in your MIX_HOME (defaults to ~/.mix). This version of Rebar will be used as required by mix deps.compile. Command line options rebar PATH - specifies a path or URL for rebar rebar3 PATH - specifies a path or URL for rebar3 --sha512 - checks the archive matches the given SHA-512 checksum --force - forces installation without a shell prompt; primarily intended for automation in build systems like make Mirrors If you want to change the default mirror to use for fetching rebar please set the HEX_MIRROR environment variable."},{"ref":"Mix.Tasks.New.html","title":"Mix.Tasks.New","type":"task","doc":"Creates a new Elixir project. It expects the path of the project as argument. mix new PATH [--sup] [--module MODULE] [--app APP] [--umbrella] A project at the given PATH will be created. The application name and module name will be retrieved from the path, unless --module or --app is given. A --sup option can be given to generate an OTP application skeleton including a supervision tree. Normally an app is generated without a supervisor and without the app callback. An --umbrella option can be given to generate an umbrella project. An --app option can be given in order to name the OTP application for the project. A --module option can be given in order to name the modules in the generated code skeleton. Examples mix new hello_world Is equivalent to: mix new hello_world --module HelloWorld To generate an app with a supervision tree and an application callback: mix new hello_world --sup To generate an umbrella application with sub applications: mix new hello_world --umbrella cd hello_world/apps mix new child_app"},{"ref":"Mix.Tasks.Profile.Cprof.html","title":"Mix.Tasks.Profile.Cprof","type":"task","doc":"Profiles the given file or expression using Erlang&#39;s cprof tool. cprof can be useful when you want to discover the bottlenecks related to function calls. Before running the code, it invokes the app.start task which compiles and loads your project. Then the target expression is profiled, together with all matching function calls, by setting breakpoints containing counters. These can only be set on BEAM code so BIFs cannot be call count traced. To profile the code, you can use syntax similar to the mix run task: mix profile.cprof -e Hello.world mix profile.cprof -e &quot;[1, 2, 3] |&gt; Enum.reverse |&gt; Enum.map(&amp;Integer.to_string/1)&quot; mix profile.cprof my_script.exs arg1 arg2 arg3 This task is automatically reenabled, so you can profile multiple times in the same Mix invocation. Command line options --matching - only profile calls matching the given Module.function/arity pattern --limit - filters out any results with a call count less than the limit --module - filters out any results not pertaining to the given module --config, -c - loads the given configuration file --eval, -e - evaluate the given code --require, -r - requires pattern before running the command --parallel, -p - makes all requires parallel --no-compile - does not compile even if files require compilation --no-deps-check - does not check dependencies --no-archives-check - does not check archives --no-halt - does not halt the system after running the command --no-start - does not start applications after compilation --no-elixir-version-check - does not check the Elixir version from mix.exs Profile output Example output: CNT Total 15 Enum 6 &lt;-- Enum.&quot;-map/2-lists^map/1-0-&quot;/2 4 Enum.reverse/1 1 Enum.map/2 1 :elixir_compiler 4 &lt;-- anonymous fn/1 in :elixir_compiler.__FILE__/1 3 anonymous fn/0 in :elixir_compiler.__FILE__/1 1 String.Chars.Integer 3 &lt;-- String.Chars.Integer.to_string/1 3 :erlang 2 &lt;-- :erlang.trace_pattern/3 2 Profile done over 20229 matching functions The default output contains data gathered from all matching functions. The left column structures each module and its total call count trace is presented on the right. Each module has its count discriminated by function below. The &lt;-- symbol is meant to help visualize where a new module call count begins. The first row (Total) is the sum of all function calls. In the last row the number of matching functions that were considered for profiling is presented. When --matching option is specified, call count tracing will be started only for the functions matching the given pattern: String.Chars.Integer 3 &lt;-- String.Chars.Integer.to_string/1 3 Profile done over 1 matching functions The pattern can be a module name, such as String to count all calls to that module, a call without arity, such as String.split, to count all calls to that function regardless of arity, or a call with arity, such as String.split/2, to count all calls to that exact module, function and arity. Caveats You should be aware the profiler is stopped as soon as the code has finished running. This may need special attention, when: running asynchronous code as function calls which were called before the profiler stopped will not be counted; running synchronous code as long running computations and a profiler without a proper MFA trace pattern or filter may lead to a result set which is difficult to comprehend. Other caveats are the impossibility to call count trace BIFs, since breakpoints can only be set on BEAM code; functions calls performed by :cprof are not traced; the maximum size of a call counter is equal to the host machine&#39;s word size (for example, 2147483647 in a 32-bit host)."},{"ref":"Mix.Tasks.Profile.Cprof.html#profile/2","title":"Mix.Tasks.Profile.Cprof.profile/2","type":"function","doc":"Allows to programmatically run the cprof profiler on expression in fun. Options :matching - only profile calls matching the given pattern in form of {module, function, arity}, where each element may be replaced by :_ to allow any value :limit - filters out any results with a call count less than the limit :module - filters out any results not pertaining to the given module"},{"ref":"Mix.Tasks.Profile.Eprof.html","title":"Mix.Tasks.Profile.Eprof","type":"task","doc":"Profiles the given file or expression using Erlang&#39;s eprof tool. :eprof provides time information of each function call and can be useful when you want to discover the bottlenecks related to this. Before running the code, it invokes the app.start task which compiles and loads your project. Then the target expression is profiled, together with all matching function calls using the Erlang trace BIFs. The tracing of the function calls for that is enabled when the profiling is begun, and disabled when profiling is stopped. To profile the code, you can use syntax similar to the mix run task: mix profile.eprof -e Hello.world mix profile.eprof -e &quot;[1, 2, 3] |&gt; Enum.reverse |&gt; Enum.map(&amp;Integer.to_string/1)&quot; mix profile.eprof my_script.exs arg1 arg2 arg3 This task is automatically reenabled, so you can profile multiple times in the same Mix invocation. Command line options --matching - only profile calls matching the given Module.function/arity pattern --calls - filters out any results with a call count lower than this --time - filters out any results that took lower than specified (in µs) --sort - sorts the results by time or calls (default: time) --config, -c - loads the given configuration file --eval, -e - evaluates the given code --require, -r - requires pattern before running the command --parallel, -p - makes all requires parallel --no-warmup - skips the warmup step before profiling --no-compile - does not compile even if files require compilation --no-deps-check - does not check dependencies --no-archives-check - does not check archives --no-halt - does not halt the system after running the command --no-start - does not start applications after compilation --no-elixir-version-check - does not check the Elixir version from mix.exs Profile output Example output: # CALLS % TIME µS/CALL Total 24 100.0 26 1.08 Enum.reduce_range_inc/4 5 3.85 1 0.20 :erlang.make_fun/3 1 7.69 2 2.00 Enum.each/2 1 7.69 2 2.00 anonymous fn/0 in :elixir_compiler_0.__FILE__/1 1 7.69 2 2.00 :erlang.integer_to_binary/1 5 15.39 4 0.80 :erlang.apply/2 1 15.39 4 4.00 anonymous fn/3 in Enum.each/2 5 19.23 5 1.00 String.Chars.Integer.to_string/1 5 23.08 6 1.20 Profile done over 8 matching functions The default output contains data gathered from all matching functions. The first row after the header contains the sums of the partial results and the average time for all the function calls listed. The following rows contain the function call, followed by the number of times that the function was called, then by the percentage of time that the call uses, then the total time for that function in microseconds, and, finally, the average time per call in microseconds. When --matching option is specified, call count tracing will be started only for the functions matching the given pattern: # CALLS % TIME µS/CALL Total 5 100.0 6 1.20 String.Chars.Integer.to_string/1 5 100.0 6 1.20 Profile done over 1 matching functions The pattern can be a module name, such as String to count all calls to that module, a call without arity, such as String.split, to count all calls to that function regardless of arity, or a call with arity, such as String.split/2, to count all calls to that exact module, function and arity. Caveats You should be aware that the code being profiled is running in an anonymous function which is invoked by :eprof module. Thus, you&#39;ll see some additional entries in your profile output. It is also important to notice that the profiler is stopped as soon as the code has finished running, and this may need special attention, when: running asynchronous code as function calls which were called before the profiler stopped will not be counted; running synchronous code as long running computations and a profiler without a proper MFA trace pattern or filter may lead to a result set which is difficult to comprehend. You should expect a slowdown in your code execution using this tool since :eprof has some performance impact on the execution, but the impact is considerably lower than Mix.Tasks.Profile.Fprof. If you have a large system try to profile a limited scenario or focus on the main modules or processes. Another alternative is to use Mix.Tasks.Profile.Cprof that uses :cprof and has a low performance degradation effect."},{"ref":"Mix.Tasks.Profile.Eprof.html#print_function_count/1","title":"Mix.Tasks.Profile.Eprof.print_function_count/1","type":"function","doc":""},{"ref":"Mix.Tasks.Profile.Eprof.html#profile/2","title":"Mix.Tasks.Profile.Eprof.profile/2","type":"function","doc":"Allows to programmatically run the eprof profiler on expression in fun. Options :matching - only profile calls matching the given pattern in form of {module, function, arity}, where each element may be replaced by :_ to allow any value :calls - filters out any results with a call count lower than this :time - filters out any results that took lower than specified (in µs) :sort - sort the results by :time or :calls (default: :time)"},{"ref":"Mix.Tasks.Profile.Fprof.html","title":"Mix.Tasks.Profile.Fprof","type":"task","doc":"Profiles the given file or expression using Erlang&#39;s fprof tool. fprof can be useful when you want to discover the bottlenecks of a sequential code. Before running the code, it invokes the app.start task which compiles and loads your project. Then the target expression is profiled, together with all processes which are spawned by it. Other processes (e.g. those residing in the OTP application supervision tree) are not profiled. To profile the code, you can use syntax similar to the mix run task: mix profile.fprof -e Hello.world mix profile.fprof my_script.exs arg1 arg2 arg3 This task is automatically reenabled, so you can profile multiple times in the same Mix invocation. Command line options --callers - prints detailed information about immediate callers and called functions --details - includes profile data for each profiled process --sort key - sorts the output by given key: acc (default) or own --config, -c - loads the given configuration file --eval, -e - evaluates the given code --require, -r - requires pattern before running the command --parallel, -p - makes all requires parallel --no-compile - does not compile even if files require compilation --no-deps-check - does not check dependencies --no-archives-check - does not check archives --no-start - does not start applications after compilation --no-elixir-version-check - does not check the Elixir version from mix.exs --no-warmup - does not execute code once before profiling Profile output Example output: # CNT ACC (ms) OWN (ms) Total 200279 1972.188 1964.579 :fprof.apply_start_stop/4 0 1972.188 0.012 anonymous fn/0 in :elixir_compiler_2 1 1972.167 0.001 Test.run/0 1 1972.166 0.007 Test.do_something/1 3 1972.131 0.040 Test.bottleneck/0 1 1599.490 0.007 ... The default output contains data gathered from all profiled processes. All times are wall clock milliseconds. The columns have the following meaning: CNT - total number of invocations of the given function ACC - total time spent in the function OWN - time spent in the function, excluding the time of called functions The first row (Total) is the sum of all functions executed in all profiled processes. For the given output, we had a total of 200279 function calls and spent about 2 seconds running the code. More detailed information is returned if you provide the --callers and --details options. When --callers option is specified, you&#39;ll see expanded function entries: Mod.caller1/0 3 200.000 0.017 Mod.caller2/0 2 100.000 0.017 Mod.some_function/0 5 300.000 0.017 &lt;-- Mod.called1/0 4 250.000 0.010 Mod.called2/0 1 50.000 0.030 Here, the arrow (&lt;--) indicates the marked function - the function described by this paragraph. You also see its immediate callers (above) and called functions (below). All the values of caller functions describe the marked function. For example, the first row means that Mod.caller1/0 invoked Mod.some_function/0 3 times. 200ms of the total time spent in Mod.some_function/0 was spent processing calls from this particular caller. In contrast, the values for the called functions describe those functions, but in the context of the marked function. For example, the last row means that Mod.called2/0 was called once by Mod.some_function/0, and in that case the total time spent in the function was 50ms. For a detailed explanation it&#39;s worth reading the analysis in Erlang/OTP documentation for fprof. Caveats You should be aware that the code being profiled is running in an anonymous function which is invoked by :fprof module. Thus, you&#39;ll see some additional entries in your profile output, such as :fprof calls, an anonymous function with high ACC time, or an :undefined function which represents the outer caller (non-profiled code which started the profiler). Also, keep in mind that profiling might significantly increase the running time of the profiled processes. This might skew your results if, for example, those processes perform some I/O operations, since running time of those operations will remain unchanged, while CPU bound operations of the profiled processes might take significantly longer. Thus, when profiling some intensive program, try to reduce such dependencies, or be aware of the resulting bias. Finally, it&#39;s advised to profile your program with the prod environment, since this should provide more realistic insights into bottlenecks."},{"ref":"Mix.Tasks.Profile.Fprof.html#profile/2","title":"Mix.Tasks.Profile.Fprof.profile/2","type":"function","doc":"Allows to programmatically run the fprof profiler on expression in fun. Options :callers - prints detailed information about immediate callers and called functions :details - includes profile data for each profiled process :sort - sorts the output by given key: :acc (default) or :own"},{"ref":"Mix.Tasks.Run.html","title":"Mix.Tasks.Run","type":"task","doc":"Starts the current application and runs code. mix run can be used to start the current application dependencies, the application itself, and optionally run some code in its context. For long running systems, this is typically done with the --no-halt option: mix run --no-halt Once the current application and its dependencies have been started, you can run a script in its context by passing a filename: mix run my_app_script.exs arg1 arg2 arg3 Code to be executed can also be passed inline with the -e option: mix run -e &quot;DbUtils.delete_old_records()&quot; -- arg1 arg2 arg3 In both cases, the command-line arguments for the script or expression are available in System.argv/0. Before doing anything, Mix will compile the current application if needed, unless you pass --no-compile. If for some reason the application needs to be configured before it is started, the --no-start option can be used and you are then responsible for starting all applications by using functions such as Application.ensure_all_started/1. For more information about the application life-cycle and dynamically configuring applications, see the Application module. If you need to pass options to the Elixir executable at the same time you use mix run, it can be done as follows: elixir --sname hello -S mix run --no-halt This task is automatically reenabled, so it can be called multiple times with different arguments. Command-line options --config, -c - loads the given configuration file --eval, -e - evaluates the given code --require, -r - executes the given pattern/file --parallel, -p - makes all requires parallel --preload-modules - preloads all modules defined in applications --no-compile - does not compile even if files require compilation --no-deps-check - does not check dependencies --no-archives-check - does not check archives --no-halt - does not halt the system after running the command --no-mix-exs - allows the command to run even if there is no mix.exs --no-start - does not start applications after compilation --no-elixir-version-check - does not check the Elixir version from mix.exs"},{"ref":"Mix.Tasks.Test.html","title":"Mix.Tasks.Test","type":"task","doc":"Runs the tests for a project. This task starts the current application, loads up test/test_helper.exs and then requires all files matching the test/**/*_test.exs pattern in parallel. A list of files can be given after the task name in order to select the files to compile: mix test test/some/particular/file_test.exs Command line options --color - enables color in the output --cover - runs coverage tool. See &quot;Coverage&quot; section below --exclude - excludes tests that match the filter --failed - runs only tests that failed the last time they ran --force - forces compilation regardless of modification times --formatter - formatter module --include - includes tests that match the filter --listen-on-stdin - runs tests, and then listens on stdin. Receiving a newline will result in the tests being run again. Very useful when combined with --stale and external commands which produce output on stdout upon file system modification --max-cases - sets the maximum number of tests running async. Only tests from different modules run in parallel. Defaults to twice the number of cores --max-failures - the suite stops evaluating tests when this number of test failures is reached. When not given, it always runs all tests --no-archives-check - does not check archives --no-color - disables color in the output --no-compile - does not compile, even if files require compilation --no-deps-check - does not check dependencies --no-elixir-version-check - does not check the Elixir version from mix.exs --no-start - does not start applications after compilation --only - runs only tests that match the filter --preload-modules - preloads all modules defined in applications --raise - raises if the test suite failed --seed - seeds the random number generator used to randomize the order of tests; --seed 0 disables randomization --slowest - prints timing information for the N slowest tests. Automatically sets --trace and --preload-modules --stale - runs only tests which reference modules that changed since the last time tests were ran with --stale. You can read more about this option in the &quot;Stale&quot; section below --timeout - sets the timeout for the tests --trace - runs tests with detailed reporting. Automatically sets --max-cases to 1. Note that in trace mode test timeouts will be ignored See ExUnit.configure/1 for more information on configuration options. Filters ExUnit provides tags and filtering functionality that allow developers to select which tests to run. The most common functionality is to exclude some particular tests from running by default in your test helper file: # Exclude all external tests from running ExUnit.configure exclude: [external: true] Then, whenever desired, those tests could be included in the run via the --include option: mix test --include external:true The example above will run all tests that have the external option set to true. It is also possible to include all examples that have a given tag, regardless of its value: mix test --include external Note that all tests are included by default, so unless they are excluded first (either in the test helper or via the --exclude option) the --include option has no effect. For this reason, Mix also provides an --only option that excludes all tests and includes only the given ones: mix test --only external Which is similar to: mix test --include external --exclude test It differs in that the test suite will fail if no tests are executed when the --only option is used. In case a single file is being tested, it is possible to pass a specific line number: mix test test/some/particular/file_test.exs:12 Which is equivalent to: mix test --only line:12 test/some/particular/file_test.exs If the given line starts a describe block, the line filter runs all tests in it. Otherwise, it runs the closest test on or before the given line number. Note that in the case where a single file contains more than one test module (test case), the line filter applies to every test case before the given line number. Thus, more than one test might be executed for the run. Configuration :test_paths - list of paths containing test files. Defaults to [&quot;test&quot;] if the test directory exists; otherwise, it defaults to []. It is expected that all test paths contain a test_helper.exs file :test_pattern - a pattern to load test files. Defaults to *_test.exs :warn_test_pattern - a pattern to match potentially misnamed test files and display a warning. Defaults to *_test.ex :test_coverage - a set of options to be passed down to the coverage mechanism Coverage The :test_coverage configuration accepts the following options: :output - the output directory for cover results. Defaults to &quot;cover&quot; :tool - the coverage tool :summary - summary output configuration; can be either a boolean or a keyword list. When a keyword list is passed, it can specify a :threshold, which is a boolean or numeric value that enables coloring of code coverage results in red or green depending on whether the percentage is below or above the specified threshold, respectively. Defaults to [threshold: 90] By default, a very simple wrapper around OTP&#39;s cover is used as a tool, but it can be overridden as follows: def project() do [ ... test_coverage: [tool: CoverModule] ... ] end CoverModule can be any module that exports start/2, receiving the compilation path and the test_coverage options as arguments. It must return either nil or an anonymous function of zero arity that will be run after the test suite is done. &quot;Stale&quot; The --stale command line option attempts to run only those test files which reference modules that have changed since the last time you ran this task with --stale. The first time this task is run with --stale, all tests are run and a manifest is generated. On subsequent runs, a test file is marked &quot;stale&quot; if any modules it references (and any modules those modules reference, recursively) were modified since the last run with --stale. A test file is also marked &quot;stale&quot; if it has been changed since the last run with --stale."},{"ref":"Mix.Tasks.Test.html#formatter_opts/1","title":"Mix.Tasks.Test.formatter_opts/1","type":"function","doc":""},{"ref":"Mix.Tasks.Xref.html","title":"Mix.Tasks.Xref","type":"task","doc":"Performs cross reference checks between modules. The unreachable and deprecated checks below happen every time your project is compiled via mix compile.xref. See Mix.Tasks.Compile.Xref for more information. This task is automatically reenabled, so you can perform multiple cross reference checks in the same Mix invocation. Xref modes The xref task expects a mode as first argument: mix xref MODE All available modes are discussed below. unreachable Prints all unreachable &quot;file:line: module.function/arity&quot; entries: mix xref unreachable The &quot;file:line&quot; represents the file and line a call to an unknown &quot;module.function/arity&quot; is made. The option --abort-if-any can be used for the command to fail if unreachable calls exist. deprecated Prints all deprecated &quot;file:line: module.function/arity&quot; entries: mix xref deprecated The &quot;file:line&quot; represents the file and line a call to a deprecated &quot;module.function/arity&quot; is made. This operation does not show deprecated local calls (a call to a deprecated function or macro in the same module) nor calls to deprecated functionality in Elixir itself. The option --abort-if-any can be used for the command to fail if deprecated calls exist. callers CALLEE Prints all callers of the given CALLEE, which can be one of: Module, Module.function, or Module.function/arity. Examples: mix xref callers MyMod mix xref callers MyMod.fun mix xref callers MyMod.fun/3 graph Prints a file dependency graph where an edge from A to B indicates that A (source) depends on B (sink). mix xref graph --format stats The following options are accepted: --exclude - paths to exclude --label - only shows relationships with the given label The labels are &quot;compile&quot;, &quot;struct&quot; and &quot;runtime&quot; --only-nodes - only shows the node names (no edges) --source - displays all files that the given source file references (directly or indirectly) --sink - displays all files that reference the given file (directly or indirectly) --format - can be set to one of: pretty - prints the graph to the terminal using Unicode characters. Each prints each file followed by the files it depends on. This is the default except on Windows; plain - the same as pretty except ASCII characters are used instead of Unicode characters. This is the default on Windows; stats - prints general statistics about the graph; dot - produces a DOT graph description in xref_graph.dot in the current directory. Warning: this will override any previously generated file The --source and --sink options are particularly useful when trying to understand how the modules in a particular file interact with the whole system. You can combine those options with --label and --only-nodes to get all files that exhibit a certain property, for example: # To get all files that depend on lib/foo.ex mix xref graph --sink lib/foo.ex --only-nodes # To get all files that depend on lib/foo.ex at compile time mix xref graph --label compile --sink lib/foo.ex --only-nodes # To show general statistics about the graph mix xref graph --format stats # To limit statistics only to certain labels mix xref graph --format stats --label compile Shared options Those options are shared across all modes: --include-siblings - includes dependencies that have :in_umbrella set to true in the current project in the reports. This can be used to find callers or to analyze graphs between projects --no-compile - does not compile even if files require compilation --no-deps-check - does not check dependencies --no-archives-check - does not check archives --no-elixir-version-check - does not check the Elixir version from mix.exs Configuration All configuration for Xref should be placed under the key :xref. :exclude - a list of modules and {module, function, arity} tuples to ignore when checking cross references. For example: [MissingModule, {MissingModule2, :missing_func, 2}]"},{"ref":"Mix.Tasks.Xref.html#calls/1","title":"Mix.Tasks.Xref.calls/1","type":"function","doc":"Returns a list of information of all the function calls in the project. Each item in the list is a map with the following keys: :callee - a tuple containing the module, function, and arity of the call :line - an integer representing the line where the function is called :file - a binary representing the file where the function is called :caller_module - the module where the function is called This function returns an empty list when used at the root of an umbrella project because there is no compile manifest to extract the function call information from. To get the function calls of each child in an umbrella, execute the function at the root of each individual application."}]